<?php

class stat_api
{

	//from GET
	protected $token="";
	protected $action="";

	//from sql
	protected $node=0;

	public function __construct()
	{
		$this->route();
	}

	protected function check_stat_token()
	{
		global $CONFIG;
		if (array_key_exists('stat_token', $CONFIG) && ($this->token == $CONFIG['stat_token']))
		{
			return true;
		}
		return false;
	}

	protected function route()
	{
		global $vGET;
		$vGET=getgetvars();
		global $vPOST;
		$vPOST=array();

		openlog('sys-admin[api]',0,LOG_DAEMON);

		$this->token=gp_str('token');
		$this->action=gp_str('action');

		if ($this->check_stat_token())
		{
			DBconnect();

			switch ($this->action)
			{
				case "cstat":
					$this->a_cstat();
					break;
				default:
					$this->details();
					break;
			}

		}
		else
		{
			sleep(10);
			echo "ERROR (auth failed)\n";
			http_response_code(403);
		}
	}

	protected function txtheader()
	{
		header('Content-Type: text/plain; charset=UTF-8');
	}

	protected function details()
	{
		$this->txtheader();
		echo "Error: no such action\n";
		http_response_code(404);
	}

	protected function a_cstat()
	{
		$this->txtheader();

		$client_arr=array();

		$csql="SELECT client.id AS id, client.name AS name,
			client.quota AS quota,
			client.mailquota AS mailquota,
			IFNULL(stats_ftp.usage, 0) AS `usage`,
			COUNT(mail_users.id) AS mboxno,
			CEIL(IFNULL(SUM(stats_mail.usage), 0)) AS `mailusage`,
			client.active AS active,
			client.suspend AS suspend
			FROM client
			LEFT JOIN stats_ftp ON client.id=stats_ftp.clientid
			LEFT JOIN domain ON domain.clientid=client.id
			LEFT JOIN mail_users ON mail_users.domainid=domain.id
			LEFT JOIN stats_mail ON stats_mail.mailid=mail_users.id
			WHERE stats_ftp.ftpid IS NULL

			GROUP BY client.id
			ORDER BY client.id;";


		// vhost stats

		$vhsql="SELECT t1.cliid AS id, sum(t1.avgdata) AS `data`, sum(t1.avgcpu) AS `cpu`
			FROM (
				SELECT client.id AS cliid,
				ROUND(IFNULL(AVG(stats_vhost.data),0)) AS `avgdata`,
				ROUND(IFNULL(AVG(stats_vhost.cpu),0)) AS `avgcpu`
			FROM vhosts
			LEFT JOIN domain ON vhosts.domainid=domain.id
			LEFT JOIN client ON domain.clientid=client.id
			LEFT JOIN stats_vhost ON vhosts.id=stats_vhost.vhostid
			WHERE (stats_vhost.modified >= DATE_ADD(NOW(),INTERVAL -1 MONTH))

			GROUP BY vhosts.id
			) AS t1
			GROUP BY t1.cliid;";


		// MySQL stats
		$dbsql="SELECT client.id AS id, (SUM(IFNULL(stats_mysql.data, 0)+IFNULL(stats_mysql.idx,0))) AS `mysql_data`
			FROM client
			LEFT JOIN stats_mysql ON stats_mysql.clientid=client.id
			GROUP BY client.id;";

		$Result=DBquery($csql);

		if ($Result->num_rows)
		{

			$vhResult=DBquery($vhsql);
			$vhstat=array();
			while ($vhRow=$vhResult->fetch_assoc())
			{
				$vhstat[$vhRow['id']]=$vhRow;
			}

			$dbResult=DBquery($dbsql);
			$dbstat=array();
			while ($dbRow=$dbResult->fetch_assoc())
			{
				$dbstat[$dbRow['id']]=$dbRow;
			}

			while($Row=$Result->fetch_assoc())
			{
				$Row['all_usage']=$Row['usage'];
				$Row['vh_data']=0;
				$Row['vh_cpu']=0;
				$Row['db_data']=0;

				if (array_key_exists($Row['id'], $vhstat))
				{
					if (array_key_exists('data', $vhstat[$Row['id']]))
					{
						$Row['vh_data']=$vhstat[$Row['id']]['data'];
					}
					if (array_key_exists('cpu', $vhstat[$Row['id']]))
					{
						$Row['vh_cpu']=$vhstat[$Row['id']]['cpu'];
					}
				}
				if (array_key_exists($Row['id'], $dbstat))
				{
					if (array_key_exists('mysql_data', $dbstat[$Row['id']]))
					{
						$Row['db_data']=$dbstat[$Row['id']]['mysql_data'];
					}
				}

				if (!($Row['vh_data'])) { $Row['vh_data']=0; }
				if (!($Row['vh_cpu'])) { $Row['vh_cpu']=0; }
				if (!($Row['db_data'])) { $Row['db_data']=0; }

				$Row['all_usage']=($Row['usage']+$Row['db_data']);

				$client_arr[$Row['name']]=$Row;
			}

#			print_r($client_arr);
			echo json_encode($client_arr, JSON_NUMERIC_CHECK | JSON_PRETTY_PRINT);
		}

	}

}
