<?php

class vhost_api
{

	//from GET
	protected $vhid=0;
	protected $token="";
	protected $action="";

	//from sql
	protected $vhname="";
	protected $vhssl=0;
	protected $node=0;
	protected $deployid=NULL;

	public function __construct()
	{
		$this->route();
	}

	protected function route()
	{
		global $vGET;
		$vGET=getgetvars();
		global $vPOST;
		$vPOST=array();

		openlog('sys-admin[api]',0,LOG_DAEMON);

		$this->vhid=gp_int('vh');
		$this->token=gp_str('token');
		$this->action=gp_str('action');

		if ($this->vhid != 0 && $this->token != "")
		{
			DBconnect();
			if (check_vhost_token($this->vhid, $this->token, false))
			{
				$this->vhname=get_vhost($this->vhid);
				$this->vhssl=get_vhost_ssl($this->vhid);
				$this->node=get_node_vhost($this->vhid);
				$this->deployid=get_vhost_deployid($this->vhid);

				switch ($this->action)
				{
					case "install":
						$this->a_mwp_off();
						break;
					case "mwp_off":
						$this->a_mwp_off();
						break;
					case "fixrights":
						$this->a_mwp_on();
						break;
					case "mwp_on":
						$this->a_mwp_on();
						break;
					case "mwp_status":
						$this->a_mwp_status();
						break;
					case "writable_list":
						$this->a_writable_list();
						break;
					case "deploy":
						$this->a_deploy();
						break;
					case "deploy_status":
						$this->a_deploy_status();
						break;
					default:
						$this->details();
						break;
				}
			}
			else
			{
				sleep(10);
				echo "ERROR (auth failed)\n";
				http_response_code(403);
			}
		}
	}


	protected function a_mwp_off()
	{
		sleep(1);
		$isql="UPDATE `vhosts` SET `rights`=3 WHERE `id`='".$this->vhid."';";
		check_mysql_query($isql);
		$this->activate_var('rights_update');
		apply_activation();
		http_response_code(202);
		$this->txtheader();
		echo "OK (protection off $this->vhid)\n";
	}

	protected function a_mwp_on()
	{
		sleep(1);
		$fsql="UPDATE `vhosts` SET `rights`=2 WHERE `id`='".$this->vhid."';";
		check_mysql_query($fsql);
		$this->activate_var('rights_update');
		apply_activation();
		http_response_code(202);
		$this->txtheader();
		echo "OK (protection on $this->vhid)\n";
	}

	protected function a_mwp_status()
	{
		$ssql="SELECT `rights` FROM `vhosts` WHERE `id`='".$this->vhid."';";
		$ret=get_sql($ssql,'rights');
		$this->txtheader();
		echo "$ret";
	}

	protected function a_writable_list()
	{
		$ssql="SELECT `writable` FROM `vhosts` WHERE `id`='".$this->vhid."';";
		$ret=get_sql($ssql,'writable');
		$this->txtheader();
		echo "$ret";
	}

	protected function a_deploy()
	{
		if ($this->deployid)
		{
			sleep(1);
			$isql="UPDATE `deploy` SET `deploy`=1 WHERE `id`='".$this->deployid."';";
			check_mysql_query($isql);
			$this->activate_var('deploy');
			apply_activation();
			http_response_code(202);
			$this->txtheader();
			echo "OK (deploy $this->deployid)\n";
		}
	}

	protected function a_deploy_status()
	{
		$ssql="SELECT `deploy` FROM `deploy` WHERE `id`='".$this->deployid."';";
		$ret=get_sql($ssql,'deploy');
		$this->txtheader();
		echo "$ret";
	}

// Display details section //

	public function display_link($file, $inner=NULL)
	{
		$protocol = $this->vhssl==1 ? 'https' : 'http';
		$url=$protocol."://".$this->vhname."/".$this->token."/".$file;
		$url_html='<u>'.$protocol."://".$this->vhname."/".'<b style="color:green">'.$this->token.'</b>'."/".'<b style="color:blue">'.$file.'</b></u>';
		if ($inner) { $link_inner=$inner; } else { $link_inner=$url_html; }
		return "<a href=\"$url\" target=\"_blank\">$link_inner</a>\n";
	}

	public function display_api_link($action=NULL, $inner=NULL)
	{
		global $CONFIG;
		$act="";
		$act_html="";
		$protocol = isset($_SERVER["HTTPS"]) ? 'https' : 'http';
		if ($action)
		{
			$act="&action=".$action;
		}
		$url=$CONFIG['rdir']."/api-vhost.php?vh=".$this->vhid."&token=".$this->token.$act;
		$url_full=$protocol."://".$_SERVER['HTTP_HOST'].$url;

		$url_html='<u>'.$protocol."://".$_SERVER['HTTP_HOST'].$CONFIG['rdir'].'/api-vhost.php';
		$url_html.='?<b style="color:maroon">vh</b>=<b style="color:purple">'.$this->vhid.'</b>';
		$url_html.='&<b style="color:olive">token</b>=<b style="color:green">'.$this->token.'</b>';
		if ($action)
		{
			$url_html.='&<b style="color:teal">action</b>=<b style="color:blue">'.$action.'</b>';
		}
		$url_html.='</u>';

		if ($inner) { $link_inner=$inner; } else { $link_inner=$url_html; }
		return "<a href=\"".$url_full."\" target=\"_blank\">".$link_inner."</a>\n";
	}

	public function display_img($image)
	{
		global $CONFIG;
		$img="<img src=\"".$CONFIG['rdir']."/image/".$image."\">";
		return $img;
	}
	protected function details()
	{
		global $CONFIG;
		$this->htmlheader();

		echo "<h2>".$this->vhname."</h2>\n";
		echo "<table id='main' width='100%'><tr><td>\n";

		echo "<table class='data' id='stat'>\n";
		echo "<tr><th width=300>Log, Statisztika</th><th width=16></th><th>URL</th><th>Megjegyzés</th></tr>\n";
		echo "<tr><td>Webstatisztika</td><td>".$this->display_img("manage_vhost.png")."</td><td>".$this->display_link("stat")."</td><td>A statisztikában csak a dinamikus tartalom szerepel (PHP, átirányítások, stb.)</td></tr>\n";
		echo "<tr><td>Accesslog</td><td>".$this->display_img("log.png")."</td><td>".$this->display_link("access.log")."</td><td>Az Apache accesslog is csak a dinamikus tartalmat tartalmazza.</td></tr>\n";
		echo "<tr><td>Errorlog</td><td>".$this->display_img("log.png")."</td><td>".$this->display_link("error.log")."</td><td>Apache hibaüzenetek, PHP nélkül</td></tr>\n";
		echo "<tr><td>Log Archive</td><td>".$this->display_img("log.png")."</td><td>".$this->display_link("logs")."</td><td>Az összes Apache log</td></tr>\n";
		echo "<tr><td>PHP log</td><td>".$this->display_img("log.png")."</td><td>".$this->display_link("php.log")."</td><td>PHP hibaüzenetek (csak ERROR és WARNING)</td></tr>\n";
		echo "</table>\n";
		echo "<br>\n";

		echo "<table class='data' id='api'>\n";
		echo "<tr><th width=300>API funkció</th><th width=16></th><th>URL</th><th>Megjegyzés</th></tr>\n";
		echo "<tr><td>API info (ez az oldal)</td><td>".$this->display_img("api.png")."</td><td>".$this->display_api_link()."</td><td>Ennek az info oldalnak a címe</td></tr>\n";
		echo "<tr><td>Malware védelem státusz</td><td>".$this->display_img("lock.png")."</td><td>".$this->display_api_link("mwp_status")."</td><td>0=Aktív (csak a megadott könyvtárak írhatók), 1=Felfüggesztve (minden írható) - telepítéshez, frissítéshez</td></tr>\n";
		echo "<tr><td>Írható könyvtárak listája</td><td>".$this->display_img("folder-edit.png")."</td><td>".$this->display_api_link("writable_list")."</td><td>Ezek a könyvtárak akkor is írhatók maradnak, ha a malware védelem aktív. (Ezekben a könyvtárakban PHP script futtatása direktben nem lehetséges)</td></tr>\n";

		echo "<tr><td>Automata (Git) deployment státusz</td><td>".$this->display_img("deploy.png")."</td><td>";
		if ($this->deployid) { echo $this->display_api_link("deploy_status"); } else { echo '- (nincs beállítva automata deployment)'; }
		echo "</td><td>0=Legutóbbi deploy folyamat sikeres, 1=Deploy folyamatban, 2=Hiba a legutóbbi deploy folyamat során, 3=Kapcsolat létrehozása sikertelen a Git szerverrel</td></tr>\n";

		echo "<tr><td><b>Figyelem!</b></td><td></td><td><b>Az alábbi API funkciók visszakérdezés nélkül lefutnak:</b></td><td></td></tr>\n";

		echo "<tr><td>Malware védelem aktiválása</td><td>".$this->display_img("lock.png")."</td><td>".$this->display_api_link("mwp_on")."</td><td>Az oldal tartalma írásvédetté válik, a megadott könyvtárak kivételével.</td></tr>\n";
		echo "<tr><td>Malware védelem felfüggesztése (install mód)</td><td>".$this->display_img("lockopen.png")."</td><td>".$this->display_api_link("mwp_off")."</td><td>Az oldal tartalma írhatóvá válik a PHP által, lehetővé téve az oldal frissítését, pluginek telepítését, stb.</td></tr>\n";

		echo "<tr><td>Automata (Git) deployment</td><td>".$this->display_img("deploy.png")."</td><td>";
		if ($this->deployid) { echo $this->display_api_link("deploy"); } else { echo '- (nincs beállítva automata deployment)'; }
		echo "</td><td>Az oldal tartalma frissül a távoli Git repositoryból. A Git által kezelt fájlok felülíródnak, minden más érintetlen marad.</td></tr>\n";

		echo "</table>\n";

		echo "</td></tr></table>\n";

		$this->pageclose();
	}

	protected function htmlheader()
	{

		global $CONFIG;

		header('Content-Type: text/html; charset=utf-8');
		echo "<!DOCTYPE html>\n";
		echo "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n";

		echo "<head>\n";
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
		echo "<link href=\"$CONFIG[rdir]/config/style.css\" rel=\"stylesheet\" type=\"text/css\">\n";

		echo "<title>".$this->vhname."</title>\n";

		echo "</head>\n";
		echo "<body>\n";
		echo "<center>\n";
	}

	protected function txtheader()
	{
		header('Content-Type: text/plain; charset=UTF-8');
	}

	protected function pageclose()
	{
		echo "</center>\n";
		echo "</body>\n";
		echo "</html>\n";
	}

	function activate_var($key)
	{
		if ($this->node)
		{
			$asql="UPDATE var SET `value`=1 WHERE `key`='$key' AND `node`='".$this->node."';";
			check_mysql_query($asql);
		}
	}

}

?>
