<?php

function check_exist_client($cliname, $display_error=true) {

	$chksql="SELECT id FROM client WHERE name='$cliname'; ";

	if (check_mysql_result($chksql)) {
		if ($display_error) { echo "<h4>Ez az ügyfél már létezik!</h4>\n"; }
		return false;
	}
	return true;
}

function check_exist_cliftp($ftpname, $cliid, $display_error=true) {

	$chksql="SELECT cli_ftp.id FROM cli_ftp
		LEFT JOIN client ON cli_ftp.clientid=client.id
		WHERE client.id='$cliid'
		AND cli_ftp.name='$ftpname'; ";

	if (check_mysql_result($chksql)) {
		if ($display_error) { echo "<h4>Ez az FTP elérés már létezik!</h4>\n"; }
		return false;
	}
	return true;
}

function check_exist_domain($domname, $display_error=true) {

	$chksql="SELECT id FROM domain WHERE name='$domname'; ";

	if (check_mysql_result($chksql)) {
		if ($display_error) { echo "<h4>Ez a domain már létezik!</h4>\n"; }
		return false;
	}
	return true;
}

function check_exist_host($hostname, $domid, $display_error=true) {

	$chksql="SELECT dom_host.id AS id FROM dom_host
		LEFT JOIN domain ON dom_host.domainid=domain.id
			WHERE domain.id='$domid'
		AND dom_host.host='$hostname'; ";

	if (check_mysql_result($chksql))
	{
		if ($display_error) { echo "<h4>Ez a host már létezik!</h4>\n"; }
		return false;
	}

	// no host can be added if there is a CNAME with the given hostname
	$chkrsql="SELECT dom_records.id AS id FROM dom_records
		LEFT JOIN domain ON dom_records.domainid=domain.id
		WHERE domain.id='$domid'
		AND dom_records.type='CNAME'
		AND dom_records.host='$hostname'; ";

	if (check_mysql_result($chkrsql))
	{
		if ($display_error) { echo "<h4>Ilyen hostnévvel már létezik <b>CNAME DNS rekord</b>.</h4>\n"; }
		return false;
	}

	return true;
}

function check_exist_domrec($hostname, $domid, $type, $display_error=true) {

	// this rule is for record types that must be the only one of the type (only known are CNAME,A,AAAA)
	if ($type=='CNAME' || $type=='A')
	{

		$chkrsql="SELECT dom_records.id AS id FROM dom_records
			LEFT JOIN domain ON dom_records.domainid=domain.id
			WHERE domain.id='$domid'
			AND dom_records.type='$type'
			AND dom_records.host='$hostname'; ";

		if (check_mysql_result($chkrsql))
		{
			if ($display_error) { echo "<h4>Ilyen <b>DNS rekord</b> már létezik!</h4>\n"; }
			return false;
		}
	}

	if ($type=='CNAME')
	{
		// check if the same hostname exists
		$chksql="SELECT dom_host.id AS id FROM dom_host
			LEFT JOIN domain ON dom_host.domainid=domain.id
			WHERE domain.id='$domid'
			AND dom_host.host='$hostname'; ";

		if (check_mysql_result($chksql))
		{
			if ($display_error) { echo "<h4>Ilyen <b>hostnév</b> már létezik!</h4>\n"; }
			return false;
		}


		//if any other record exists with the same hostname, the CNAME is invalid
		$chkorsql="SELECT dom_records.id AS id FROM dom_records
			LEFT JOIN domain ON dom_records.domainid=domain.id
			WHERE domain.id='$domid'
			AND dom_records.host='$hostname'; ";

		if (check_mysql_result($chkorsql))
		{
			if ($display_error) { echo "<h4>A hostnév szerepel egyéb DNS rekordban, CNAME rekord nem vehető fel.</h4>\n"; }
			return false;
		}

		// the domain name and the wildcard cannot be CNAME
		$unusable_cnames=array('@', '', '*');
		if (in_array($hostname, $unusable_cnames))
		{
			if ($display_error) { echo "<h4>Ez a hostnév nem használható CNAME rekordként.</h4>\n"; }
			return false;
		}

		// we generate some default hostnames if the MX is local
		$mailhosts=array("mail", "webmail", "smtp", "imap", "imap4", "pop", "pop3");

		$mxsql="SELECT `id` FROM domain
				WHERE domain.id='$domid'
				AND `mx` IS NULL;";

		if (check_mysql_result($mxsql) && in_array($hostname, $mailhosts))
		{
			if ($display_error) { echo "<h4>Ilyen <b>hostnév</b> már létezik! Megszüntetéséhez a <b>Levelezést</b> ki kell kapcsolni.</h4>\n"; }
			return false;
		}

	}

	// no record can be added if there is a CNAME with the given hostname
	if ($type!='CNAME')
	{
		$chkrsql="SELECT dom_records.id AS id FROM dom_records
			LEFT JOIN domain ON dom_records.domainid=domain.id
			WHERE domain.id='$domid'
			AND dom_records.type='CNAME'
			AND dom_records.host='$hostname'; ";

		if (check_mysql_result($chkrsql))
		{
			if ($display_error) { echo "<h4>Ilyen hostnévvel már létezik <b>CNAME DNS rekord</b>.</h4>\n"; }
			return false;
		}
	}

	return true;
}

function check_exist_mailuser($name, $domid, $hostid=NULL, $display_error=true) {

	$chksql="SELECT mail_users.id AS id FROM mail_users
			LEFT JOIN domain ON mail_users.domainid=domain.id
			LEFT JOIN dom_host ON mail_users.hostid=dom_host.id
			WHERE domain.id='$domid'
			";

	if ($hostid)
	{
		$chksql.="AND dom_host.id='$hostid' ";
	}
	else
	{
		$chksql.="AND dom_host.id IS NULL ";
	}

		$chksql.="AND mail_users.name='$name';";

	if (check_mysql_result($chksql)) {
		if ($display_error) { echo "<h4>Ez a postafiók már létezik!</h4>\n"; }
		return false;
	}
	return true;
}

function check_exist_mailalias($alias, $domid, $hostid=NULL, $display_error=true) {

	$chksql="SELECT mail_aliases.id AS id FROM mail_aliases
			LEFT JOIN domain ON mail_aliases.domainid=domain.id
			LEFT JOIN dom_host ON mail_aliases.hostid=dom_host.id
			WHERE domain.id='$domid'
			";

	if ($hostid)
	{
		$chksql.="AND dom_host.id='$hostid' ";
	}
	else
	{
		$chksql.="AND dom_host.id IS NULL ";
	}

	$chksql.="AND mail_aliases.alias='$alias'; ";

	if (check_mysql_result($chksql)) {
		if ($display_error) { echo "<h4>Ez az alias cím már létezik!</h4>\n"; }
		return false;
	}
	return true;
}

function check_exist_mysql($db, $cliid, $display_error=true) {
	$chksql="SELECT mysql.id FROM mysql
		LEFT JOIN client ON mysql.clientid=client.id
		WHERE client.id='$cliid'
		AND mysql.name='$db'; ";

	if (check_mysql_result($chksql)) {
		if ($display_error) { echo "<h4>Ez a MySQL adatbázis/elérés már létezik!</h4>\n"; }
		return false;
	}
	return true;
}

function check_exist_vhost($host, $aliases, $xaliases, $domid, $display_error=true) {

	$domname=get_domain($domid);

	// make an array of all the hostnames

	$avsql="SELECT vhosts.id AS id, vhosts.domainid AS domainid, domain.name AS domname, vhosts.host AS host, vhosts.alias AS alias, vhosts.ext_alias AS ext_alias
		FROM vhosts
		LEFT JOIN domain ON vhosts.domainid=domain.id;";
	$avResult = DBquery($avsql);

	$allhostnames=array();

	while ($avRow=$avResult->fetch_assoc()) {

	$vhdom=$avRow['domname'];
	$vhhost=$avRow['host'];

	$allhostnames[]="$vhhost.$vhdom";

		$allaliasarray=multirow2array($avRow['alias']);
	foreach($allaliasarray as $allalias) { $allhostnames[]="$allalias.$vhdom"; }

	$allxaliasarray=multirow2array($avRow['ext_alias']);
	foreach($allxaliasarray as $allxalias) { $allhostnames[]="$allxalias"; }
	}

	// new vhost array

	$hostnames=array();
	$hostnames[]="$host.$domname";

	$aliasarray=multirow2array($aliases);
	foreach($aliasarray as $alias) { $hostnames[]="$alias.$domname"; }

	$xaliasarray=multirow2array($xaliases);
	foreach($xaliasarray as $xalias) { $hostnames[]="$xalias"; }
	
	//compare arrays

	$diff=array_diff($hostnames, $allhostnames);


	if (count($hostnames)!=count($diff))
	{
	$duplicates=array_diff($hostnames, $diff);
	foreach ($duplicates as $dup) {
		if ($display_error) { echo "<h4>A(z) $dup hostnév már létezik!</h4>\n"; }
	}
	return false;
	}
	return true;
}

function check_exist_vhostdeploy($vhid, $display_error=true) {

	$chksql="SELECT `deploy`.`vhostid` AS `id`
		FROM `deploy`
		WHERE `deploy`.`vhostid`='$vhid';";

	if (check_mysql_result($chksql)) {
		if ($display_error) { echo "<h4>Ehhez a weboldalhoz már létezik automata deploy!</h4>\n"; }
		return false;
	}
	return true;
}

