<?php

//check if query returns rows
function check_mysql_result($query)
{
	$chkResult = DBquery($query);
	if ($chkResult->num_rows==0)
	{
		return false;
	}
	else
	{
		return true;
	}
}

//check if query successful
function check_mysql_query($query)
{
	$qResult=DBquery($query);
	if (!($qResult))
	{
		echo "<h4>Adatbázis hiba!</h4>\n";
		echo "<h4><i>$query</i></h4>";
		suicide();
	}
}

// enforce user, adminlogin, adminlevel
function enforce_mysql_access($ignore_clientid=false)
{
	global $adminlogin;
	global $adminlevel;
	global $clientid;

	$sql="";

	//if admin
	if ($adminlogin==1 && $adminlevel < 2)
	{
		// this is just an example, we're not using it
		// if adminlevel is 1 clients over cat 1 will be hidden
		$sql.=" AND `client`.`category` < 2 ";	
	}
	elseif ($adminlogin==1 && $adminlevel < 4)
	{
		// if adminlevel in 1,2,3 clients over cat 4 will be hidden
		$sql.=" AND `client`.`category` < 5 ";	
	}

	//if not admin
	if ($ignore_clientid)
	{
	   	if ($adminlogin != 1)
		{
			$sql.=" AND `client`.`id`='".$clientid."' ";
		}
	}
	else
	{
	   	if ($clientid != 0 || $adminlogin != 1)
		{
			$sql.=" AND `client`.`id`='".$clientid."' ";
		}
	}

	return $sql;
}

function check_mysql_access($chkid, $chkquery, $desc, $display_error=true)
{
	$chkquery.=' ';
	$chkquery.=enforce_mysql_access();
	$chkquery.='; ';

	$chkResult=DBquery($chkquery);
	if ($chkResult->num_rows==0)
	{
		if ($chkid!=0)
		{
			if ($display_error) {echo "<h4>A megadott ".$desc." szerkesztéséhez nincs jogosultsága!</h4>\n";}
		}
		return false;
	}
	return true;
}

// check admin rights for client
function check_client($cliid, $display_error=true)
{
	$chksql="SELECT `id` FROM `client`
		WHERE `client`.`id`='".$cliid."' ";

	$desc="ügyfél";

	return check_mysql_access($cliid, $chksql, $desc, $display_error);
}

// check client rights for domain
function check_domain($domid, $display_error=true)
{
	$chksql="SELECT domain.id AS id FROM domain
		LEFT JOIN client ON domain.clientid=client.id
		WHERE domain.id='$domid' ";

	$desc="domain";

	return check_mysql_access($domid, $chksql, $desc, $display_error);
}

//Check client rights for host
function check_host($hostid, $display_error=true)
{
	if ($hostid != 0)
	{
		$chksql="SELECT `dom_host`.`host` AS host FROM `dom_host`
			LEFT JOIN domain ON dom_host.domainid=domain.id
			LEFT JOIN client ON domain.clientid=client.id
			WHERE dom_host.id='$hostid' ";

		$desc="aldomain (host)";

		return check_mysql_access($hostid, $chksql, $desc, $display_error);
	}
	return true;
}

//Check client rights for DNS record
function check_domrec($domrecid, $display_error=true)
{
	if ($domrecid != 0)
	{
		$chksql="SELECT `dom_records`.`host` AS host FROM `dom_records`
			LEFT JOIN domain ON dom_records.domainid=domain.id
			LEFT JOIN client ON domain.clientid=client.id
			WHERE dom_records.id='$domrecid' ";

		$desc="DNS rekord";

		return check_mysql_access($domrecid, $chksql, $desc, $display_error);
	}
	return true;
}

//check client rights for mailbox
function check_mailbox($mailboxid, $display_error=true)
{
	$chksql="SELECT mail_users.id AS id FROM mail_users
		LEFT JOIN domain ON mail_users.domainid=domain.id
		LEFT JOIN client ON domain.clientid=client.id
		WHERE mail_users.id='$mailboxid' ";

	$desc="postafiók";

	return check_mysql_access($mailboxid, $chksql, $desc, $display_error);
}

//check client rights for alias
function check_alias($aliasid, $display_error=true)
{
	$chksql="SELECT mail_aliases.id AS id FROM mail_aliases
		LEFT JOIN domain ON mail_aliases.domainid=domain.id
		LEFT JOIN client ON domain.clientid=client.id
		WHERE mail_aliases.id='$aliasid' ";

	$desc="alias";

	return check_mysql_access($aliasid, $chksql, $desc, $display_error);
}

//check client rights for ftp
function check_ftp($ftpid, $display_error=true)
{
	global $clientid;

	$chksql="SELECT cli_ftp.id AS id FROM cli_ftp
		LEFT JOIN client ON cli_ftp.clientid=client.id
		WHERE cli_ftp.id='$ftpid' ";

	$desc="FTP elérés";

	return check_mysql_access($ftpid, $chksql, $desc, $display_error);
}

//check client rights for mysql database
function check_mysql($mysqlid, $display_error=true)
{
	global $clientid;

	$chksql="SELECT mysql.id AS id FROM mysql
		LEFT JOIN client ON mysql.clientid=client.id
		WHERE mysql.id='$mysqlid' ";

	$desc="MySQL elérés";

	return check_mysql_access($mysqlid, $chksql, $desc, $display_error);
}

//check client rights for vhost
function check_vhost($vhostid, $display_error=true)
{
	global $clientid;

	$chksql="SELECT vhosts.id AS id FROM vhosts
		LEFT JOIN domain ON vhosts.domainid=domain.id
		LEFT JOIN client ON domain.clientid=client.id
		WHERE vhosts.id='$vhostid' ";

	$desc="weboldal";

	return check_mysql_access($vhostid, $chksql, $desc, $display_error);
}

function check_vhost_active($vhostid, $display_error=true)
{
	global $clientid;

	$chksql="SELECT vhosts.id AS id FROM vhosts
		LEFT JOIN domain ON vhosts.domainid=domain.id
		LEFT JOIN client ON domain.clientid=client.id
		WHERE `vhosts`.`id`='$vhostid'
		AND `vhosts`.`active`=1 ";

	$desc="weboldal";

	return check_mysql_access($vhostid, $chksql, $desc, $display_error);
}

//check client rights for auto deploy
function check_deploy($deployid, $display_error=true)
{
	global $clientid;

	$chksql="SELECT `deploy`.`id` AS `id` FROM `deploy`
		LEFT JOIN `vhosts` ON `deploy`.`vhostid`=`vhosts`.`id`
		LEFT JOIN `domain` ON `vhosts`.`domainid`=`domain`.`id`
		LEFT JOIN `client` ON `domain`.`clientid`=`client`.`id`
		WHERE `deploy`.`id`='$deployid' ";

	$desc="autodeploy összeköttetés";

	return check_mysql_access($deployid, $chksql, $desc, $display_error);
}

//check vhost+token validity
function check_vhost_token($vhostid, $token, $display_error=true)
{

	$toksql="SELECT `vhosts`.`id` AS `id` FROM `vhosts`
			WHERE `vhosts`.`id`='$vhostid'
			AND `vhosts`.`token`='$token'
			AND LENGTH(`vhosts`.`token`) > 31
			;";

	$tokResult=DBquery($toksql);

	if ($tokResult->num_rows==0)
	{
		if ($display_error) { echo "<h4>Ehhez a weboldalhoz Önnek nincs jogosultsága!</h4>\n"; }
		return false;
	}
	return true;
}

