<?php

// ekezetes domainek
function domuni($dom,$prefix='',$suffix='') {
    if (substr($dom,0,4)=="xn--") {

	$IDN = new idna_convert();
	$domuni = $IDN->decode($dom);

	if ($dom != $domuni) {
	    $dom="$prefix$domuni$suffix";
	}
    }
    return $dom;
}

function setformfocus() {
    echo "<script>document.sysadminform.elements[0].focus()</script>";
}

function unidom($dom,$prefix='',$suffix='') {
    $dom=strtolower($dom);
    if ( preg_match("#[áéíóöőúüű]+#", $dom) ) {
	$IDN = new idna_convert();
	$pdom = $IDN->encode($dom);
	if ($dom != $pdom) {
	    $dom="$prefix$pdom$suffix";
	}
    }
    return $dom;
}

function hidepassword($pass) {
    $passcrypt="";
    for ($p = 0; $p < strlen($pass); $p++) {
	$passcrypt .= "*";
    }
    return $passcrypt;
}

//generate password
function createpassword($length=8) {

    //min.length=8
    if ($length<8) { $length=8; }

    $set_lower='abcdefghijkmnopqrstuvwxyz';
    $set_upper='ABCDEFGHJKLMNOPQRSTUVWXYZ';
    $set_num='234567890';
    $set_chr='-.^';

    $set_all=str_shuffle($set_lower.$set_upper.$set_num.$set_chr);
    $set_alnum=str_shuffle($set_lower.$set_upper.$set_num);

    $mid =$set_num[mt_rand(0,strlen($set_num)-1)];
    $mid.=$set_upper[mt_rand(0,strlen($set_upper)-1)];
    $mid.=$set_lower[mt_rand(0,strlen($set_lower)-1)];

    $i = 0;
 	   while ($i < ($length-5)) {
		$mid .= $set_all[mt_rand(0,strlen($set_all)-1)];
		$i++;
    }

    $password =$set_alnum[mt_rand(0,strlen($set_alnum)-1)];
    $password.=str_shuffle($mid);
    $password.=$set_alnum[mt_rand(0,strlen($set_alnum)-1)];

    return ($password);
}

function create_token($length=32) {

	//min.length=32
	if ($length<32) { $length=32; }

	$set_all=str_shuffle("abcdefghijkmnopqrstuvwxyz1234567890");

	$token="";
	for ($i=1; $i<=$length; $i++)
	{
		$token.= $set_all[mt_rand(0,strlen($set_all)-1)];
	}

	return str_shuffle($token);
}


function gen_pass($pass, $display=true) {
    global $pause;
    if ((!($pass)) || ($pass=="")) {
        $pass=createpassword(16);
		if ($display)
		{
	        echo "<h4>A jelszó: $pass</h4>";
			$pause=1;
		}
    }
    return $pass;
}

function cli_pad($clid) {
    $pad=str_pad($clid,4,"0",STR_PAD_LEFT);
    return $pad;
}

function nullquote($str) {
    if ($str==NULL) { $quoted="NULL"; } else { $quoted="'$str'"; }
    return $quoted;
}

function closewindow($func, $pause=0) {

    global $pause;

    $url=$_SERVER['SCRIPT_NAME']."?f=$func";

    if ($pause == 1) {
        echo "<input type=\"button\" value=\"Bezárás\" onmouseup=\"javascript:OpenMain('$url')\" >\n";
    } else {
        echo "<script language=\"JavaScript\">window.onload=OpenMain('$url');</script>\n";
    }
}

function refreshmainwindow($func) {
    $url=$_SERVER['SCRIPT_NAME']."?f=$func";
	echo "<script language=\"JavaScript\">window.onload=RefreshMain('$url');</script>\n";
}

function csvl2multirow($string, $delim=';')
{
	$csv_arr=str_getcsv($string, $delim);
	return implode("\n", $csv_arr);
}

function multirow2array($string, $prefix="", $suffix="") {
    $cleanstring = str_replace(array('\r', '\t' ), '', $string);
    $exploded=explode("\n",$cleanstring);
    $rows=array();
    foreach ($exploded as $row) {
	$row=trim($row);
        if ($row!="") {$rows[]="$prefix$row$suffix";}
    }
    return $rows;
}

function multirow2web($mrstring, $prefix="", $suffix="") {
    $array=multirow2array($mrstring, $prefix, $suffix);
    $return=implode("<br>\n",$array);
    return $return;
}

function activate_config($type, $node=NULL)
{
	global $CONFIG;
	if (!(array_key_exists('disabled_updates', $CONFIG) && is_array($CONFIG['disabled_updates']) && in_array($type, $CONFIG['disabled_updates'])))
	{
		$node_filter="";
		if (!(is_null($node)))
		{
			if ($node!=0)
			{
				$node_filter="AND `node`='$node';";
			}
		}
		//check_mysql_query("UPDATE var SET `value`=1, `modified`=NOW() WHERE `key`='$type' ".$node_filter.";");
		check_mysql_query("UPDATE var SET `value`=1 WHERE `key`='$type' ".$node_filter.";");
	}
}


function apply_activation() {
    global $CONFIG;
    for ($node=1; $node <= $CONFIG['nodes']; $node++)
    {
	if ($CONFIG['node'][$node]['refresh_port'])
	{
	    $fp = fsockopen("127.0.0.1", $CONFIG['node'][$node]['refresh_port'], $errno, $errstr, 4);
	    fclose($fp);
	}
    }
    return true;
}

function logme($text, $mail=false) {

    global $clientid;
    global $adminlogin;

    if ($clientid==0) { $clientname="admin"; } else { $clientname=get_client($clientid); }
    if ($adminlogin==1) { $aprefix="admin:"; }

    global $CONFIG;
    $ip=$_SERVER['REMOTE_ADDR'];
    //$txt="[$ip]: $text";
    if ($mail == true)
    {
	mail ($CONFIG['mail_admin'], "sys-admin: $text", "sys-admin [$aprefix$clientname@$ip]: $text" ,"From: sys-admin <".$CONFIG['mail_admin'].">" );
    }
    return syslog (LOG_NOTICE,"[$aprefix$clientname@$ip] ".$text);

}

function percentgraph($val,$max,$unit,$extra=0)
{
	    if ($max!=0) {
        	$percent=round($val/$max*100);
	    } else {
			$percent=0;
	    }
	    $percentgraph=$percent;
	    if ($percentgraph>=100) { $percentgraph=100; }
		$percentleft=(100-$percentgraph-20);
		$pclass="";
		$bclass="pgf0";

        if ($percent>60) { $bclass="pgf60"; }
        if ($percent>90) { $pclass="red"; $bclass="pgf90"; }
        #if ($percent>=100) { $pclass="red-blink"; }

        $ret="<div class=\"r $pclass\">";

		switch ($extra)
		{
			case 1:
 		       	$ret.="<b>$percent</b>% ($val $unit)";
				break;
			case 2:
 		       	$ret.="<b>$val</b> / $max $unit";
				break;
			case 3:
 		       	$ret.="<b>$percent</b>%";
				break;
			default:
	        	$ret.="<b>$val</b> $unit";
				break;
		}
        $ret.="</div>";
	    $ret.="<div class=\"pgb\"><div class=\"pgf $bclass\" style=\"width:$percentgraph%;\"></div></div>";
	    return $ret;
}

function split_domrec_txt($rec)
{
	$rec=trim($rec, '" ');
	$rec=preg_replace('/\"[ ]*\"/', '', $rec);
	if (strlen($rec)>253)
	{
		$rec=chunk_split($rec, 250, '" "');
		$rec=trim($rec, '" ');
	}
	$rec="\"$rec\"";
	return $rec;
}

function null_if_false(&$value)
{
	if (!$value)
	{
		$value=NULL;
	}
}

function gen_fqdn($host=NULL, $domain)
{
	if ($host)
	{
		return $host.'.'.$domain;
	}
	else
	{
		return $domain;
	}
}

function tablesorter($id='datatable')
{
	echo "<script>new Tablesort(document.getElementById('".$id."'));</script>\n";
}
