<?php
function DBconnect()
{
	global $MYCONN;
	global $CONFIG;

	//$MYCONN=new mysqli::connect

	$MYCONN=new mysqli($CONFIG['db_host'], $CONFIG['db_user'], $CONFIG['db_pass'], $CONFIG['db_name']);

	if ($MYCONN->connect_errno) {
		echo "<h4>Adatbázis kapcsolódási hiba!</h4>\n";
		echo "<h4><i>".$MYCONN->connect_error."</i></h4>";
		suicide();
	}

	$MYCONN->set_charset('utf8');

}

function DBquery($query, $resultmode = MYSQLI_STORE_RESULT)
{
	global $MYCONN;
	$res=$MYCONN->query($query, $resultmode);
	if ($MYCONN->errno) {
		echo "<h4>Adatbázis hiba!</h4>\n";
		echo "<h4><i>$query</i></h4>";
		echo "<h4><i>".$MYCONN->error."</i></h4>";
		suicide();
	}
	return $res;
}

/*
function DBquery_prep($query, $values, $resultmode = MYSQLI_STORE_RESULT)
{
	global $MYCONN;

	// prepare statement
	$stmt=$MYCONN->prepare($query);

	// create a temp array with ref'd values
	$tmp = array();
	foreach($values as $key => $value) $tmp[$key] = &$values[$key];

	// run statement
	call_user_func_array(array($stmt, 'bind_param'), $tmp);

	$stmt->execute();

	if ($stmt->errno) {
	echo "<h4>Adatbázis hiba!</h4>\n";
		echo "<h4><i>$query</i></h4>";
		echo "<h4><i>".$stmt->error."</i></h4>";
		suicide();
	}

	$stmt->close();

}
*/

function DBquery_prep($query, $values)
{
	$stmt=DBpq_prepare($query);
	DBpq_execute($stmt, $values);
	DBpq_close($stmt);
}

function DBpq_prepare($query)
{
	global $MYCONN;

	// prepare statement
	$stmt=$MYCONN->prepare($query);

	if ($stmt->errno)
	{
		echo "<h4>Adatbázis hiba!</h4>\n";
		echo "<h4><i>$query</i></h4>";
		echo "<h4><i>".$stmt->error."</i></h4>";
		suicide();
	}

	return $stmt;
}


function DBpq_execute($stmt, $values)
{

	// create a temp array with ref'd values
	$tmp = array();
	foreach($values as $key => $value)
	{
		$tmp[$key] = &$values[$key];
	}

	// run statement
	call_user_func_array(array($stmt, 'bind_param'), $tmp);

	if ($stmt->errno)
	{
		echo "<h4>Adatbázis hiba!</h4>\n";
		echo "<h4><i>".$stmt->error."</i></h4>";
		suicide();
	}

	$stmt->execute();

	if ($stmt->errno)
	{
		echo "<h4>Adatbázis hiba!</h4>\n";
		echo "<h4><i>".$stmt->error."</i></h4>";
		suicide();
	}
}

function DBpq_close($stmt)
{
	$stmt->close();
}

function DBgetinsertid()
{
	global $MYCONN;
	return $MYCONN->insert_id;
}

function DBclose()
{
	global $MYCONN;
	$res=$MYCONN->close();
	return $res;
}

?>
