<?php

function startmain()
{

 htmlheader();

 global $CONFIG;
 global $adminlogin;
 global $clientid;

 require $CONFIG['adir'].'/include/edit/client/functions.php';
 require $CONFIG['adir'].'/include/edit/client/forms.php';

#################################################################### route

 // get mode
 $mode=gp_str('mode');

 $ce_id= gp_str('id');
 $ce_name= strtolower(gp_str('c_name'));
 $ce_password1= gp_str('c_password1');
 $ce_password2= gp_str('c_password2');
 $ce_email= strtolower(gp_str('c_email'));
 $ce_quota= gp_int('c_quota');
 $ce_mailquota= gp_int('c_mailquota');
 $ce_node= gp_int('c_node');
 
 if ($adminlogin!=1) { $ce_id=$clientid; }

 // new Client
 if ($mode=="new") {

	if ($adminlogin==1) {
		echo '<h2>Új ügyfél felvétele</h2>';
		edit_client();
	} else {
		echo '<h4>Ügyfél felvételéhez nincs jogosultsága.</h4>';
	}

 // save new
 } elseif ($mode=="save") {

	if ($adminlogin==1) {
		echo '<h2>Új ügyfél létrehozása</h2>';

		check_form_validator();

		if
		(
			mand_str($ce_name, 'Ügyfél neve') &&
			check_format_alnum($ce_name, 'ügyfélnév') &&
			check_exist_client($ce_name) &&
			mand_str($ce_email, 'admin e-mail') &&
			check_format_email($ce_email) &&
			mand_int($ce_quota,'Tárhely') &&
			mand_int_positive($ce_mailquota,'E-mail tárhely') &&
			opt_pass($ce_password1, $ce_password2, $ce_name, '', 1) &&
			check_node($ce_node)
		)
		{
			$ce_password=gen_pass($ce_password1);
			if ((!is_numeric($ce_node))) { $ce_node=1; }

			insert_client($ce_name, $ce_quota, $ce_mailquota, $ce_email, $ce_password, $ce_node);

			//if ($ce_password != $ce_password1) { $pause=1; }

			closewindow("client");

		} else {

			edit_client ($ce_name, $ce_quota, $ce_mailquota, $ce_email, $ce_password1, $ce_password2, $ce_node);

		}
	} else {
		echo '<h4>Ügyfél létrehozásához nincs jogosultsága.</h4>';
	}

 //change client
 } elseif ($mode=="edit" && (nonzero($ce_id))) {
	echo '<h2>Ügyfél módosítása</h2>';

	if (!($ce_id > 0)) { suicide(); }
    if (!(check_client($ce_id))) { suicide(); }

	modify_client($ce_id);

 //save changed client
 } elseif ($mode=="update" && nonzero($ce_id)) {
	echo '<h2>Ügyfél mentése</h2>';

	check_form_validator();

	if (!($ce_id > 0)) { suicide(); }
    if (!(check_client($ce_id))) { suicide(); }

	$ce_name=get_client($ce_id);
	$ce_oldpass=get_clientpass($ce_id);

	if
	(
		($adminlogin!=1 || (mand_int($ce_quota,'Tárhely') && mand_int_positive($ce_mailquota,'E-mail tárhely'))) &&
		mand_str($ce_email, 'admin e-mail cím') &&
		check_format_email($ce_email) &&
		opt_pass($ce_password1, $ce_password2, $ce_name, $ce_oldpass, 1)
	)
	{
		$ce_password=gen_pass($ce_password1);

		update_client($ce_id, $ce_quota, $ce_mailquota, $ce_email, $ce_password);
		//if ($ce_password != $ce_password1) { $pause=1; }
		closewindow("client");
	}
	else
	{
		modify_client($ce_id, $ce_quota, $ce_mailquota, $ce_email, $ce_password1, $ce_password2);
	}

 //ask to delete Client
 } elseif ($mode=="del" && nonzero($ce_id)) {

	if ($adminlogin==1) {
		echo '<h2>Ügyfél törlése</h2>';

		if (!($ce_id > 0)) { suicide(); }
	    if (!(check_client($ce_id))) { suicide(); }

		ask_del($ce_id);

	} else {
		echo '<h4>Ügyfél törléséhez nincs jogosultsága.</h4>';	
	}

 //finally delete Client
 } elseif ($mode=="finaldel" && nonzero($ce_id)) {

	if ($adminlogin==1) {
		echo '<h2>Ügyfél törlése</h2>';

		check_form_validator();

		if (!($ce_id > 0)) { suicide(); }
	    if (!(check_client($ce_id))) { suicide(); }

		final_del($ce_id);

		closewindow("client");
	} else {
		echo '<h4>Ügyfél törléséhez nincs jogosultsága.</h4>';	
	}
	

 //ask to toggle on-off
 } elseif ($mode=="toggle" && nonzero($ce_id)) {

	if ($adminlogin==1)
	{
		echo '<h2>Ügyfél ki-bekapcsolása</h2>';

		if (!($ce_id > 0)) { suicide(); }
		if (!(check_client($ce_id))) { suicide(); }

		ask_toggle_client($ce_id);

	}
	else
	{
		echo '<h4>Ügyfél ki-bekapcsolásához nincs jogosultsága.</h4>';	
	}


 //toggle on-off
 } elseif ($mode=="finaltoggle" && nonzero($ce_id)) {

	if ($adminlogin==1)
	{
		echo '<h2>Ügyfél ki-bekapcsolása</h2>';

		check_form_validator();

		if (!($ce_id > 0)) { suicide(); }
		if (!(check_client($ce_id))) { suicide(); }

		toggle_client($ce_id);

		closewindow("client");
	}
	else
	{
		echo '<h4>Ügyfél ki-bekapcsolásához nincs jogosultsága.</h4>';	
	}

 //toggle suspend
 } elseif ($mode=="suspend" && nonzero($ce_id)) {

	if ($adminlogin==1) {
		echo '<h2>Ügyfél korlátozása</h2>';
		if (!($ce_id > 0)) { suicide(); }
		if (!(check_client($ce_id))) { suicide(); }

		ask_toggle_suspend_client($ce_id);

	}
	else
	{
		echo '<h4>Ügyfél korlátozásához nincs jogosultsága.</h4>';
	}

 } elseif ($mode=="finalsuspend" && nonzero($ce_id)) {

	if ($adminlogin==1) {
		echo '<h2>Ügyfél korlátozása</h2>';

		check_form_validator();

		if (!($ce_id > 0)) { suicide(); }
		if (!(check_client($ce_id))) { suicide(); }

		toggle_suspend_client($ce_id);

		closewindow("client");
	}
	else
	{
		echo '<h4>Ügyfél korlátozásához nincs jogosultsága.</h4>';
	}

 } else {
	echo '<h4>Hibás paraméterezés.</h4>';
	pageclose();
	die();
 }

 DBclose();
 pageclose();
 exit (0);
}
?>