<?php

function edit_deploy($de_vhid=NULL, $de_repo=NULL, $de_branch=NULL, $de_login=NULL, $de_password=NULL, $de_hook_pre=NULL, $de_hook_post=NULL) {

	global $clientid;
	global $CONFIG;

	require_once($CONFIG['adir'].'/include/dropdown.function.php');

	// Form + table start
	echo "<form action=\"".$_SERVER['SCRIPT_NAME']."?f=deploy&e=1&mode=save\" method=\"post\" name=\"sysadminform\">\n";
	add_form_validator();
	echo "<table class=\"edittable\">\n";

	//comment
	echo "<tr>\n";
	echo "<td colspan=\"2\"><i><b>Figyelem! Automata deployment beállításával a weboldal jelenlegi tartalma elveszhet!<b></i></td>\n";
	echo "</tr>\n";


	// vhost
	echo "<tr>\n";
	echo "<td><strong>Weboldal:</strong></td>\n";
	echo "<td>";
	dropdown_vhosts($de_vhid);
	echo "</td>\n";
	echo "</tr>\n";

	//comment
	echo "<tr>\n";
	echo "<td colspan=\"2\"><i>Automatikusan frissíteni kívánt weboldal</i></td>\n";
	echo "</tr>\n";

	// repository
	echo "<tr>\n";
	echo "<td><strong>GIT repository címe:</strong></td>\n";
	echo "<td><input type=\"text\" name=\"d_repo\" value=\"$de_repo\"></td>\n";
	echo "</tr>\n";

	//comment
	echo "<tr>\n";
	echo "<td colspan=\"2\"><i>A GIT repository, amiből automatikusan frissülni fog a weboldal.<br>";
	echo "(pl.: <b>https://git-server/repo.git/</b>)<br>";
	echo "Minden GIT által támogatott protokoll és formátum használható.<br>";
	echo "</i></td>\n";
	echo "</tr>\n";

	// branch
	echo "<tr>\n";
	echo "<td><strong>Branch:</strong></td>\n";
	echo "<td><input type=\"text\" name=\"d_branch\" value=\"$de_branch\"></td>\n";
	echo "</tr>\n";

	//comment
	echo "<tr>\n";
	echo "<td colspan=\"2\"><i>A használni kívánt branch neve (üresen hagyva: <b>master</b>)</i></td>\n";
	echo "</tr>\n";

	// login
	echo "<tr>\n";
	echo "<td><strong>Login:</strong></td>\n";
	echo "<td><input type=\"text\" name=\"d_login\" value=\"$de_login\"></td>\n";
	echo "</tr>\n";

	// password
	echo "<tr>\n";
	echo "<td><strong>Jelszó:</strong></td>\n";
	echo "<td><input type=\"password\" name=\"d_password\" value=\"$de_password\"></td>\n";
	echo "</tr>\n";

	//comment
	echo "<tr>\n";
	echo "<td colspan=\"2\"><i>A repository belépési adatai (tároljuk, többet nem kell beírni)</i></td>\n";
	echo "</tr>\n";

	// pre-commit hook
	echo "<tr>\n";
	echo "<td><strong>Deploy előtti hook:</strong></td>\n";
	echo "<td>https://weboldal-neve/ <input type=\"text\" name=\"d_hook_pre\" value=\"$de_hook_pre\"></td>\n";
	echo "</tr>\n";

	// post-commit hook
	echo "<tr>\n";
	echo "<td><strong>Deploy utáni hook:</strong></td>\n";
	echo "<td>https://weboldal-neve/ <input type=\"text\" name=\"d_hook_post\" value=\"$de_hook_post\"></td>\n";
	echo "</tr>\n";

	//comment
	echo "<tr>\n";
	echo "<td colspan=\"2\"><i>A megadott hook URL-eket automatikusan meghívja a rendszer deploy előtt és után.<br>\n";
	echo "(A weboldal neve <b>utáni</b> részt kell csak megadni.)</i></td>\n";
	echo "</tr>\n";

	//submit
	echo "<tr>\n";
	echo "<td></td>\n";
	echo "<td><input type=\"submit\" value=\"OK\"> <input type=\"button\" value=\"Mégse\" onmouseup=\"javascript:self.close()\"></td>\n";
	echo "<td></td>\n";
	echo "</tr>\n";

	//form end
	echo "</table>\n";
	echo "</form>\n";
	setformfocus();
}

function modify_deploy ($de_id, $de_hook_pre=NULL, $de_hook_post=NULL) {

	global $clientid;
	global $CONFIG;

    	$dsql ="SELECT deploy.hook_pre AS hook_pre,
			deploy.hook_post AS hook_post,
			vhosts.host AS host,
			domain.name AS domainname
		FROM deploy
		LEFT JOIN vhosts ON deploy.vhostid=vhosts.id
		LEFT JOIN domain ON vhosts.domainid=domain.id
		WHERE deploy.id=\"$de_id\";";

    $dResult=DBquery($dsql);
    $dRow=$dResult->fetch_assoc();

	if ($de_hook_pre == NULL) { $de_hook_pre = $dRow['hook_pre']; }
	if ($de_hook_post == NULL) { $de_hook_post = $dRow['hook_post']; }

	$vhname=$dRow['host'].'.'.$dRow['domainname'];

	// Form + table start
	echo "<form action=\"".$_SERVER['SCRIPT_NAME']."?f=deploy&e=1&mode=update&id=$de_id\" method=\"post\" name=\"sysadminform\">\n";
	add_form_validator();
	echo "<table class=\"edittable\">\n";

	// pre-commit hook
	echo "<tr>\n";
	echo "<td><strong>Deploy előtti hook:</strong></td>\n";
	echo "<td>https://$vhname/ <input type=\"text\" name=\"d_hook_pre\" value=\"$de_hook_pre\"></td>\n";
	echo "</tr>\n";

	// post-commit hook
	echo "<tr>\n";
	echo "<td><strong>Deploy utáni hook:</strong></td>\n";
	echo "<td>https://$vhname/ <input type=\"text\" name=\"d_hook_post\" value=\"$de_hook_post\"></td>\n";
	echo "</tr>\n";

	//comment
	echo "<tr>\n";
	echo "<td colspan=\"2\"><i>A megadott hook URL-eket automatikusan meghívja a rendszer deploy előtt és után.<br>\n";
	echo "(A weboldal neve <b>utáni</b> részt kell csak megadni.)</i></td>\n";
	echo "</tr>\n";

	//submit
	echo "<tr>\n";
	echo "<td></td>\n";
	echo "<td><input type=\"submit\" value=\"OK\"> <input type=\"button\" value=\"Mégse\" onmouseup=\"javascript:self.close()\"></td>\n";
	echo "<td></td>\n";
	echo "</tr>\n";

	//form end
	echo "</table>\n";
	echo "</form>\n";
	setformfocus();

}

function ask_deploy($deployid) {

    global $clientid;

	$vhname=get_deploy_vhost($deployid);

    // Form + table start
    echo "<form action=\"".$_SERVER['SCRIPT_NAME']."?f=deploy&e=1&mode=finaldeploy&id=$deployid\" method=\"post\" name=\"sysadminform\">\n";
    add_form_validator();
    echo "<table class=\"edittable\">\n";

    //comment
    echo "<tr>\n";
    echo "<td>Valóban frissíteni szeretné a <b>$vhname</b> weboldal tartalmát? (deploy/checkout)</td>\n";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td></td>\n";
    echo "</tr>\n";

    //submit
    echo "<tr>\n";
    echo "<td><input type=\"submit\" value=\"OK\"> <input type=\"button\" value=\"Mégse\" onmouseup=\"javascript:self.close()\"></td>\n";
    echo "</tr>\n";

    //form end
    echo "</table>\n";
    echo "</form>\n";
}

function ask_del($deployid) {

    global $clientid;

	$vhname=get_deploy_vhost($deployid);

    // Form + table start
    echo "<form action=\"".$_SERVER['SCRIPT_NAME']."?f=deploy&e=1&mode=finaldel&id=$deployid\" method=\"post\" name=\"sysadminform\">\n";
    add_form_validator();
    echo "<table class=\"edittable\">\n";

    //comment
    echo "<tr>\n";
    echo "<td>Valóban megszünteti a(z) <b>$vhname</b> weboldal kapcsolatát a repository-val?</td>\n";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "<td></td>\n";
    echo "</tr>\n";

    //submit
    echo "<tr>\n";
    echo "<td><input type=\"submit\" value=\"OK\"> <input type=\"button\" value=\"Mégse\" onmouseup=\"javascript:self.close()\"></td>\n";
    echo "</tr>\n";

    //form end
    echo "</table>\n";
    echo "</form>\n";
}


?>
