<?php

function startmain()
{

 htmlheader();

 global $CONFIG;
 global $adminlogin;
 global $clientid;

 require $CONFIG['adir'].'/include/edit/domain/functions.php';
 require $CONFIG['adir'].'/include/edit/domain/forms.php';

#################################################################### route

 // get mode
 $mode=gp_str('mode');

 $de_id=gp_int('id');

 if ($clientid == 0) { $de_cliid=gp_int('cliid'); } else { $de_cliid=$clientid; }

 $de_domain=strtolower(gp_str('d_domain'));

 $de_dns= gp_int('d_dns');
 $de_ip= gp_str('d_ip');
 $de_mxon= gp_int('d_mxon');
 $de_mx= strtolower(gp_str('d_mx'));
 $de_spf= gp_str('d_spf');
 $de_dkim= gp_int('d_dkim');
 $de_dmarc= gp_raw_trim('d_dmarc');
# $de_dmarc= gp_str('d_dmarc');

 if ($adminlogin != 1) {
    $de_cliid=$clientid;
 }

 // new domain
 if ($mode=="new") {
    echo '<h2>Új Domainnév felvétele</h2>';

    edit_domain();

 // save new
 } elseif ($mode=="save") {
    echo '<h2>Új Domainnév létrehozása</h2>';

    check_form_validator();

    if ($de_domain) {
	$de_unidomain=unidom($de_domain);
    }

    if (
	    mand_int($de_cliid, 'Ügyfél') &&
		check_client($de_cliid) &&
	    mand_str($de_domain, 'Domainnév') &&
	    check_format_domain($de_domain) &&
	    check_exist_domain($de_unidomain) &&
	    mand_int($de_dns, 'DNS') &&
	    (!$de_ip || check_format_ip($de_ip)) &&
	    mand_int($de_mxon, 'MX') &&
	    (!$de_mx || check_format_multirow_mx($de_mx)) &&
		(!$de_spf || check_format_spf($de_spf)) &&
		(!$de_dmarc || check_format_dmarc($de_dmarc)) &&
		((($de_dns == 0) && ($de_mxon == 0)) || (check_registered_domain($de_unidomain, true))) &&
	    opt_int($de_dkim, 'DKIM')
    )
    {
        insert_domain($de_cliid, $de_unidomain, $de_dns, $de_ip, $de_mxon, $de_mx, $de_spf, $de_dkim, $de_dmarc);
        closewindow("domain");

    } else {
        edit_domain ($de_cliid, $de_domain, $de_dns, $de_ip, $de_mxon, $de_mx, $de_spf, $de_dkim, $de_dmarc);
    }

 //change domain
 } elseif ($mode=="edit" && (nonzero($de_id))) {
    echo '<h2>Domain adatok módosítása</h2>';

    if (!(check_domain($de_id))) { suicide(); }

    modify_domain($de_id);

 //save changed domain
 } elseif ($mode=="update" && nonzero($de_id)) {
    echo '<h2>Domain adatok mentése</h2>';

    check_form_validator();

    if (!(check_domain($de_id))) { suicide(); }

    if (
	mand_int($de_id, 'Domain') &&
	mand_int($de_dns, 'DNS') &&
	(!$de_ip || check_format_ip($de_ip)) &&
	mand_int($de_mxon, 'MX') &&
	(!$de_mx || check_format_multirow_mx($de_mx)) &&
	(!$de_spf || check_format_spf($de_spf)) &&
	(!$de_dmarc || check_format_dmarc($de_dmarc)) &&
	opt_int($de_dkim, 'DKIM')
    )
    {
	update_domain($de_id, $de_dns, $de_ip, $de_mxon, $de_mx, $de_spf, $de_dkim, $de_dmarc);
	closewindow("domain");
    } else {
	modify_domain($de_id, $de_dns, $de_ip, $de_mxon, $de_mx, $de_spf, $de_dkim, $de_dmarc);
    }

 //refresh all domains
 } elseif ($mode=="refresh_all") {
    echo '<h2>Minden domain frissítése</h2>';

	if ($adminlogin != 1) { suicide(); }

    refresh_all();

    closewindow("domain");

 //ask to delete domain
 } elseif ($mode=="del" && nonzero($de_id)) {
    echo '<h2>Domain törlése</h2>';

    if (!(check_domain($de_id))) { suicide(); }

    ask_del($de_id);    

 //finally delete domain
 } elseif ($mode=="finaldel" && nonzero($de_id)) {
    echo '<h2>Domain végleges törlése</h2>';

    check_form_validator();

    if (!(check_domain($de_id))) { suicide(); }

    final_del($de_id);

    closewindow("domain");

 //ask toggle
 } elseif ($mode=="toggle" && nonzero($de_id)) {
    echo '<h2>Domain ki-bekapcsolása</h2>';

    if (!(check_domain($de_id))) { suicide(); }

    ask_toggle_domain($de_id);

 //toggle on-off
 } elseif ($mode=="finaltoggle" && nonzero($de_id)) {
    echo '<h2>Domain ki-bekapcsolása</h2>';

    check_form_validator();

    if (!(check_domain($de_id))) { suicide(); }

    toggle_domain($de_id);

    closewindow("domain");

 } else {
    echo '<h4>Hibás paraméterezés.</h4>';
    pageclose();
    die();
 }

 DBclose();
 pageclose();
 exit (0);
}
