<?php

function insert_domain($de_cliid, $de_domain, $de_dns=1, $de_ip=NULL, $de_mxon, $de_mx=NULL, $de_spf=NULL, $de_dkim=NULL, $de_dmarc=NULL)
{

	global $adminlogin;
	global $clientid;
	global $CONFIG;

	check_registered_domain($de_domain, false);

	if ($adminlogin!=1)
	{
		$de_cliid=$clientid;
#		$de_dns=1;
#		unset($de_ip);
#		$de_mxon=1;
#		unset($de_mx);
	}

	if ($de_dkim!=1) { $de_dkim=0; }
#	$di_ip=nullquote($de_ip);
#	$di_spf=nullquote($de_spf);
#	if ($de_mxon==1) { $di_mx="NULL"; } else { $di_mx="'$de_mx'"; }
	if ($de_mxon==1) { $de_mx=NULL; }
	if ($de_dns==1) { $de_dkim=0; }
#	$nsql="INSERT INTO domain SET clientid='$de_cliid', name='$de_domain', dns='$de_dns', ip=$di_ip, mx=$di_mx, spf=$di_spf;";
#	check_mysql_query($nsql);
	$nsql="INSERT INTO domain SET clientid=?, name=?, dns=?, ip=?, mx=?, spf=?, dkim=?, dmarc=?, modified=NOW();";
	$nvalues=array('ssssssss', $de_cliid, $de_domain, $de_dns, $de_ip, $de_mx, $de_spf, $de_dkim, $de_dmarc);
	DBquery_prep($nsql, $nvalues);

	$idomid=DBgetinsertid();

	activate_config('bind_update');
	activate_config('opendkim_update');

	if (!($de_ip))
	{
		global $CONFIG;
		reset($CONFIG['upstream']);
		$usid=key($CONFIG['upstream']);
		$vi_writable=nullquote(implode("\n",$CONFIG['def_writable']));
		$token=create_token(32);
		$visql="INSERT INTO `vhosts` SET `domainid`='$idomid', `host`='www', `alias`=NULL, `ext_alias`=NULL, `docroot`=NULL, `redirect`=NULL, `upstream`='$usid', `writable`=$vi_writable, `token`='$token', modified=NOW(); ";
		check_mysql_query($visql);

		$node=get_node_client($de_cliid, true);
		activate_config('apache_update', $node);
	}

	apply_activation();

	echo "<h4>A <b>$de_domain</b> domaint létrehoztuk.</h4>";
	logme ("Domain created: $de_domain", 1);
	if (!($de_ip))
	{
		echo "<h4>A domainhez létrehoztuk a <b>www.$de_domain</b> weboldalt.</h4>";
		logme ("Vhost created: www.$de_domain");
	}
}

function update_domain($de_id, $de_dns=1, $de_ip=NULL, $de_mxon, $de_mx=NULL, $de_spf=NULL, $de_dkim=NULL, $de_dmarc=NULL)
{

	global $adminlogin;

	if ($de_dkim!=1) { $de_dkim=0; }
#	$di_ip=nullquote($de_ip);
#	$di_spf=nullquote($de_spf);
#	if ($de_mxon==1) { $di_mx="NULL"; } else { $di_mx="'$de_mx'"; }
	if ($de_mxon==1) { $de_mx=NULL; }
	if ($de_dns==1) { $de_dkim=0; }
#	$usql="UPDATE domain SET dns='$de_dns', ip=$di_ip, mx=$di_mx, spf=$di_spf WHERE id='$de_id';";
#	check_mysql_query($usql);

	$usql="UPDATE domain SET dns=?, ip=?, mx=?, spf=?, dkim=?, dmarc=?, modified=NOW() WHERE id='$de_id';";
	$uvalues=array('ssssss', $de_dns, $de_ip, $de_mx, $de_spf, $de_dkim, $de_dmarc);
	DBquery_prep($usql, $uvalues);

	activate_config('bind_update');
	activate_config('opendkim_update');
	apply_activation();
	echo "<h4>A domain beállításait megváltoztattuk.</h4>";
	logme ("Domain changed: ".get_domain($de_id));
}

function toggle_domain($domainid)
{

	$gsql="SELECT active FROM domain WHERE id='$domainid';";
	$gResult=DBquery($gsql);
	$gRow=$gResult->fetch_assoc();
	$active=$gRow['active'];

	$node=get_node_domain($domainid, true);

	if ($active==1) { $setact=0; $kb="ki"; } else { $setact=1; $kb="be"; }

	$tsql="UPDATE domain SET active='$setact', modified=NOW() WHERE id='$domainid';";
	check_mysql_query($tsql);
	activate_config('bind_update');
	activate_config('opendkim_update');
	activate_config('apache_update', $node);
	apply_activation();
	echo "<h4>A domaint ".$kb."kapcsoltuk.</h4>";
	logme ("Domain toggle ($setact): ".get_domain($domainid), 1);
}

function refresh_all()
{
	$rfsql="UPDATE domain SET modified=DATE_SUB(NOW(), INTERVAL 8 MINUTE) WHERE dns=1;";
	check_mysql_query($rfsql);
	activate_config('bind_update');
	activate_config('opendkim_update');
	apply_activation();
	echo "<h4>A frissítési folyamat elkezdődött.</h4>";
	logme ("Refresh all domain zones", 1);
}

function final_del($domainid)
{

	$domainname=get_domain($domainid);
	$node=get_node_domain($domainid, true);

	// mail_users
	$dsql="DELETE FROM mail_users WHERE domainid='$domainid';";
	check_mysql_query($dsql);
	// mail_aliases
	$dsql="DELETE FROM mail_aliases WHERE domainid='$domainid';";
	check_mysql_query($dsql);

	// deploy
    $dsql="DELETE `deploy`.* FROM `deploy`
		LEFT JOIN `vhosts` ON `deploy`.`vhostid`=`vhosts`.`id`
		WHERE `vhosts`.`domainid`='$domainid';";
    check_mysql_query($dsql);

	// vhosts
	$dsql="DELETE FROM vhosts WHERE domainid='$domainid';";
	check_mysql_query($dsql);

	// domain records
	$dsql="DELETE FROM dom_records WHERE domainid='$domainid';";
	check_mysql_query($dsql);
	// domain hosts
	$dsql="DELETE FROM dom_host WHERE domainid='$domainid';";
	check_mysql_query($dsql);

	//the domain
	$dsql="DELETE FROM domain WHERE id='$domainid';";
	check_mysql_query($dsql);

	// STATS

	// mail stats
	$dssql="DELETE `stats_mail`.* FROM `stats_mail` LEFT JOIN `mail_users` ON `stats_mail`.`mailid`=`mail_users`.`id` WHERE `mail_users`.`id` IS NULL;";
	check_mysql_query($dssql);

	// vhost stats
	$dssql="DELETE `stats_vhost`.* FROM `stats_vhost` LEFT JOIN `vhosts` ON `stats_vhost`.`vhostid`=`vhosts`.`id` WHERE `vhosts`.`id` IS NULL;";
	check_mysql_query($dssql);

	activate_config('bind_update');
	activate_config('opendkim_update');
	activate_config('apache_update', $node);
	activate_config('ssl_update', $node);
	apply_activation();
	echo "<h4>A domaint töröltük.</h4>";
	logme ("Domain deleted: $domainname", 1);

}

/*
function activate_domain_config()
{
	$asql="UPDATE var SET `value`=1 WHERE `key`='bind_update';";
	check_mysql_query($asql);
}

function activate_vhost_config()
{
	$asql="UPDATE var SET `value`=1 WHERE `key`='apache_update';";
	check_mysql_query($asql);
}

function activate_ssl_gen()
{
	$asql="UPDATE var SET `value`=1 WHERE `key`='ssl_update';";
	check_mysql_query($asql);
}
*/

