<?php

function startmain()
{

 htmlheader();

 global $CONFIG;
 global $adminlogin;
 global $clientid;

 require $CONFIG['adir'].'/include/edit/domrec/functions.php';
 require $CONFIG['adir'].'/include/edit/domrec/forms.php';

#################################################################### route

 // get mode
 $mode=gp_str('mode');
 $re_id=gp_int('id');
 $re_host= strtolower(gp_str('r_host'));
 $re_domid=gp_int('m_domid');

 $re_type=gp_str('r_type');
 $re_value=gp_raw_trim('r_value');

 // new domain record
 if ($mode=="new") {
    echo '<h2>Új DNS rekord felvétele</h2>';

	edit_domrec();

 // save new
 } elseif ($mode=="save") {
    echo '<h2>Új DNS rekord létrehozása</h2>';

	check_form_validator();

	if (
		mand_str($re_host, 'Rekord (host)név') &&
		check_format_dnshost($re_type, $re_host) &&
		check_exist_domrec($re_host, $re_domid, $re_type) &&
		mand_int($re_domid, 'Domain') &&
		check_domain($re_domid) &&
		mand_str($re_type, 'Rekordtípus') &&
		mand_str($re_value, 'Érték') &&
		check_format_domrec($re_type, $re_value) &&
		check_format_domrec_spf($re_type, $re_host, $re_value) &&
		check_format_domrec_dmarc($re_type, $re_host, $re_value)
	)
	{
	    insert_domrec($re_host, $re_domid, $re_type, $re_value);

	    closewindow("domrec");

        } else {
	    edit_domrec ($re_host, $re_domid, $re_type, $re_value);
	}

 //change dns record
 } elseif ($mode=="edit" && (nonzero($re_id))) {
    echo '<h2>DNS rekord módosítása</h2>';

    if (!(check_domrec($re_id))) { suicide(); }

    modify_domrec($re_id);

 //save changed domain
 } elseif ($mode=="update" && nonzero($re_id)) {
    echo '<h2>DNS rekord mentése</h2>';

    check_form_validator();

    if (!(check_domrec($re_id))) { suicide(); }

    $rectype=get_domrec_type($re_id);

    if (
	mand_int($re_id, 'DNS rekord') &&
	mand_str($re_value, 'Érték') &&
    	check_format_domrec($rectype, $re_value)
    )
    {
	update_domrec($re_id, $re_value);
	closewindow("domrec");
    } else {
	modify_domrec($re_id, $re_value);
    }


 //ask to delete DNS record
 } elseif ($mode=="del" && nonzero($re_id)) {
    echo '<h2>DNS rekord törlése</h2>';

    if (!(check_domrec($re_id))) { suicide(); }

    ask_del($re_id);

 //finally delete DNS record
 } elseif ($mode=="finaldel" && nonzero($re_id)) {
    echo '<h2>DNS rekord végleges törlése</h2>';

    check_form_validator();

    if (!(check_domrec($re_id))) { suicide(); }

    final_del($re_id);

    closewindow("domrec");

 // ask toggle
 } elseif ($mode=="toggle" && nonzero($re_id)) {
    echo '<h2>DNS rekord ki-bekapcsolása</h2>';

    if (!(check_domrec($re_id))) { suicide(); }

    ask_toggle_domrec($re_id);

 //toggle on-off
 } elseif ($mode=="finaltoggle" && nonzero($re_id)) {
    echo '<h2>DNS rekord ki-bekapcsolása</h2>';

    check_form_validator();

    if (!(check_domrec($re_id))) { suicide(); }

    toggle_domrec($re_id);

    closewindow("domrec");

 } else {
    echo '<h4>Hibás paraméterezés.</h4>';
    pageclose();
    die();
 }

    DBclose();
    pageclose();
    exit (0);
}
