<?php

function startmain()
{

 htmlheader();

 global $CONFIG;
 global $adminlogin;
 global $clientid;

 require $CONFIG['adir'].'/include/edit/mailbox/functions.php';
 require $CONFIG['adir'].'/include/edit/mailbox/forms.php';

#################################################################### route

 // get mode
 $mode=gp_str('mode');
 $me_id=gp_int('id');

 $me_name= strtolower(gp_str('m_name'));
 $me_hostid= gp_int('m_hostid');
 $me_domid= gp_int('m_domid');
 $me_password1= gp_str('m_password1');
 $me_password2= gp_str('m_password2');
 $me_quota= gp_int('m_quota');

 // new mailbox
 if ($mode=="new") {
	echo '<h2>Új postafiók felvétele</h2>';

	edit_mb();

 // save new
 } elseif ($mode=="save") {
	echo '<h2>Új postafiók létrehozása</h2>';

	check_form_validator();

	if (!(check_domain($me_domid))) { unset($me_domid); }
	if (!(check_host($me_hostid))) { unset($me_hostid); }

	if ($clientid == 0) { $me_cliid=get_domain_cliid($me_domid); } else { $me_cliid=$clientid; }
	$maxquota=get_mailquota($me_cliid);

	if
	(
		mand_str($me_name, 'Felhasználónév') &&
		check_format_alnum_ext($me_name, 'Felhasználónév') &&
		opt_int($me_hostid,'Host') &&
		(!$me_hostid || check_host($me_hostid)) &&
		mand_int($me_domid,'Domain') &&
		check_domain($me_domid) &&
		check_exist_mailuser($me_name, $me_domid, $me_hostid) &&
		opt_pass($me_password1, $me_password2, $me_name, '') &&
		mand_int_positive($me_quota, 'Tárhely') &&
		check_mailquota($me_quota, $maxquota)
	)
	{
		$me_password=gen_pass($me_password1);
		$me_name=str_replace('*','',$me_name);

		insert_mb($me_name, $me_hostid, $me_domid, $me_password, $me_quota);

		//if ($me_password != $me_password1) { $pause=1; }

		closewindow("mailbox");

	} else {
		edit_mb ($me_domid, $me_hostid, $me_name, $me_password1, $me_password2, $me_quota);
	}

 //edit mailbox
 } elseif ($mode=="edit" && (nonzero($me_id))) {
	echo '<h2>Postafiók módosítása</h2>';

	if (!(check_mailbox($me_id))) { suicide(); }

	modify_mb($me_id);

 //save modified mailbox
 } elseif ($mode=="update" && nonzero($me_id)) {
	echo '<h2>Postafiók mentése</h2>';

	check_form_validator();

	if (!(check_mailbox($me_id))) { suicide(); }

	$me_name=get_mailbox_userpart($me_id);
	$me_oldpass=get_mailboxpass($me_id);

	if ($clientid == 0) { $me_cliid=get_mailbox_cliid($me_id); } else { $me_cliid=$clientid; }
	$maxquota=get_mailquota($me_cliid);

	if 
	(
		opt_pass($me_password1, $me_password2, $me_name, $me_oldpass) &&
		mand_int_positive($me_quota, 'Tárhely') &&
		check_mailquota($me_quota, $maxquota)
	)
	{
		$me_password=gen_pass($me_password1);

		update_mb($me_id, $me_password, $me_oldpass, $me_quota);

		//if ($me_password != $me_password1) { $pause=1; }

		closewindow("mailbox");

	} else {
		modify_mb($me_id, $me_password1, $me_password2, $me_quota);
	}

 //ask to delete mailbox
 } elseif ($mode=="del" && nonzero($me_id)) {
	echo '<h2>Postafiók törlése</h2>';

	if (!(check_mailbox($me_id))) { suicide(); }

	ask_del($me_id);	

 //finally delete mailbox
 } elseif ($mode=="finaldel" && nonzero($me_id)) {
	echo '<h2>Postafiók törlése</h2>';

	check_form_validator();

	if (!(check_mailbox($me_id))) { suicide(); }

	final_del($me_id);

	closewindow("mailbox");

 //ask smtp toggle
 } elseif ($mode=="smtp" && nonzero($me_id)) {
	echo '<h2>Levélküldés (SMTP) ki-bekapcsolása</h2>';

	if (!(check_mailbox($me_id))) { suicide(); }

	ask_toggle_smtp($me_id);

 //toggle smtp on-off
 } elseif ($mode=="finalsmtptoggle" && nonzero($me_id)) {
	echo '<h2>Levélküldés (SMTP) ki-bekapcsolása</h2>';

	check_form_validator();

	if (!(check_mailbox($me_id))) { suicide(); }

	toggle_smtp($me_id);

	closewindow("mailbox");

 //ask toggle
 } elseif ($mode=="toggle" && nonzero($me_id)) {
	echo '<h2>Postafiók ki-bekapcsolása</h2>';

	if (!(check_mailbox($me_id))) { suicide(); }

	ask_toggle_mb($me_id);

 //toggle on-off
 } elseif ($mode=="finaltoggle" && nonzero($me_id)) {
	echo '<h2>Postafiók ki-bekapcsolása</h2>';

	check_form_validator();

	if (!(check_mailbox($me_id))) { suicide(); }

	toggle_mb($me_id);

	closewindow("mailbox");

 } else {
	echo '<h4>Hibás paraméterezés.</h4>';
	pageclose();
	die();
 }

	DBclose();
	pageclose();
	exit (0);

}

?>