<?php

function startmain()
{

 htmlheader();

 global $CONFIG;
 global $adminlogin;
 global $clientid;

 require $CONFIG['adir'].'/include/edit/vhost/functions.php';
 require $CONFIG['adir'].'/include/edit/vhost/forms.php';

#################################################################### route

 // get mode
 $mode=gp_str('mode');
 $ve_id=gp_int('id');

 $ve_host= strtolower(gp_str('v_host'));
 $ve_domid= gp_int('m_domid');
 $ve_alias= strtolower(gp_str('v_alias'));
 $ve_extalias= strtolower(gp_str('v_extalias'));
 $ve_docroot= gp_str('v_docroot');
 $ve_redirect= gp_str('v_redirect');
 $ve_redirect_permanent= gp_int('v_redirect_permanent');
 $ve_usid= gp_str('v_usid');
 $ve_token= gp_str('v_token');

 //writable dirs
 $ve_writable= gp_str('v_writable');

 //settings (nginx, apache) - unclean RAW data (!)
 $ve_settingsa= gp_raw('v_settingsa');
 $ve_settingsn= gp_raw('v_settingsn');

 //php open_basedir
 $ve_openbasedir= gp_str('v_openbasedir');

 //ssl
 $ve_ssl_on= gp_int('v_ssl_on');
 $ve_ssl_mode= gp_int('v_ssl_mode');

 //rights (fix/install)
 $ve_rights= gp_int('v_rights');

 // newvhost
 if ($mode=="new") {
    echo '<h2>Új weboldal felvétele</h2>';

    edit_vhost();

 // save new
 } elseif ($mode=="save") {
    echo '<h2>Új weboldal létrehozása</h2>';

    check_form_validator();

    if (
	mand_int($ve_domid, 'Domain') &&
	check_domain($ve_domid) &&
	mand_str($ve_host, 'Weboldal címe') &&
	check_format_vhost($ve_host,true,false,true) &&
	check_exist_vhost($ve_host, $ve_alias, $ve_extalias, $ve_domid) &&
	check_upstream($ve_usid, $ve_domid, null) &&
	(!$ve_alias || check_format_multirow_vhost($ve_alias,false)) &&
	(!$ve_extalias || check_format_multirow_vhost($ve_extalias,true)) &&
	(!$ve_docroot || check_format_dir($ve_docroot)) &&
	(!$ve_redirect || check_format_url($ve_redirect)) &&
	opt_int($ve_redirect_permanent, '"Átirányítástípus')
	)
    {
	insert_vhost($ve_domid, $ve_host, $ve_alias, $ve_extalias, $ve_docroot, $ve_redirect, $ve_redirect_permanent, $ve_usid);

	closewindow("vhost");

    } else {
	edit_vhost ($ve_domid, $ve_host, $ve_alias, $ve_extalias, $ve_docroot, $ve_redirect, $ve_redirect_permanent, $ve_usid);
    }

 //change vhost
 } elseif ($mode=="edit" && (nonzero($ve_id))) {
    echo '<h2>Weboldal módosítása</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    modify_vhost($ve_id);

 //save changed vhost
 } elseif ($mode=="update" && nonzero($ve_id)) {
    echo '<h2>Weboldal mentése</h2>';

    check_form_validator();

    if (!(check_vhost($ve_id))) { suicide(); }

    if (
	(check_upstream($ve_usid, null, $ve_id)) &&
	(!$ve_alias || check_format_multirow_vhost($ve_alias,false)) &&
	(!$ve_extalias || check_format_multirow_vhost($ve_extalias,true)) &&
	(!$ve_docroot || check_format_dir($ve_docroot)) &&
	(!$ve_redirect || check_format_url($ve_redirect)) &&
	opt_int($ve_redirect_permanent, '"Átirányítástípus')
    )
    {
	update_vhost($ve_id, $ve_alias, $ve_extalias, $ve_docroot, $ve_redirect, $ve_redirect_permanent, $ve_usid, $ve_token);
	closewindow("vhost");
    } else {
	modify_vhost($ve_id, $ve_alias, $ve_extalias, $ve_docroot, $ve_redirect, $ve_redirect_permanent, $ve_usid, $ve_token);
    }

 //change writable dirs
 } elseif ($mode=="wdirs" && (nonzero($ve_id))) {
    echo '<h2>Írható könyvtárak és file-ok</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    modify_writabledirs($ve_id);

 //save changed writable dirs
 } elseif ($mode=="update_wdirs" && nonzero($ve_id)) {
    echo '<h2>Írható könyvtárak és file-ok mentése</h2>';

    check_form_validator();

    if (!(check_vhost($ve_id))) { suicide(); }

    if (
	(!$ve_writable || check_format_multirow_dir($ve_writable))
    )
    {
	update_writabledirs($ve_id, $ve_writable);
	closewindow("vhost");
    } else {
	modify_writabledirs($ve_id, $ve_writable);
    }

 //change extra settings (admin only)
 } elseif ($mode=="settings" && (nonzero($ve_id)) && $adminlogin==1) {
    echo '<h2>Webszerver egyedi beállítások</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    modify_settings($ve_id);

 //save extra settings
 } elseif ($mode=="update_settings" && nonzero($ve_id) && $adminlogin==1) {
    echo '<h2>Webszerver egyedi beállítások mentése</h2>';

    check_form_validator();

    if (!(check_vhost($ve_id))) { suicide(); }

	if (!$ve_openbasedir || check_format_multirow_dir($ve_openbasedir))
	{
		update_settings($ve_id, $ve_settingsa, $ve_settingsn, $ve_openbasedir);
	    closewindow("vhost");
	} else
	{
	    modify_settings($ve_id);
	}

 //change SSL settings (admin only)
 } elseif ($mode=="ssl" && (nonzero($ve_id)) && $adminlogin==1) {
    echo '<h2>Webszerver HTTPS beállítások</h2>';

    if (!(check_vhost_active($ve_id))) { suicide(); }

    modify_ssl($ve_id);

 //save ssl settings
 } elseif ($mode=="update_ssl" && nonzero($ve_id) && $adminlogin==1) {
    echo '<h2>Webszerver HTTPS beállítások mentése</h2>';

    check_form_validator();

    if (!(check_vhost_active($ve_id))) { suicide(); }

	update_ssl($ve_id, $ve_ssl_on, $ve_ssl_mode);
	closewindow("vhost");
#	modify_ssl($ve_id, $ve_ssl_on, $ve_ssl_mode);

 //change rights
 } elseif ($mode=="rights" && nonzero($ve_id)) {
    echo '<h2>Malware védelem</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    modify_rights($ve_id);

 //finally change rights
 } elseif ($mode=="update_rights" && nonzero($ve_id)) {
    echo '<h2>Malware védelem</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    update_rights($ve_id, $ve_rights);

    closewindow("vhost");

/*
 //ask to fix rights
 } elseif ($mode=="rightsfix" && nonzero($ve_id)) {
    echo '<h2>Védelem aktiválása</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    ask_rightsfix($ve_id);

 //finally fix rights
 } elseif ($mode=="finalrightsfix" && nonzero($ve_id)) {
    echo '<h2>Védelem aktiválása</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    final_rightsfix($ve_id);

    closewindow("vhost");

 //ask to set everything writable
 } elseif ($mode=="rightswr" && nonzero($ve_id)) {
    echo '<h2>Védelem felfüggesztése (Install)</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    ask_rightswr($ve_id);    

 //finally set everything writable
 } elseif ($mode=="finalrightswr" && nonzero($ve_id)) {
    echo '<h2>Védelem felfüggesztése (Install)</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    final_rightswr($ve_id);

    closewindow("vhost");
*/

 //ask to delete vhost
 } elseif ($mode=="del" && nonzero($ve_id)) {
    echo '<h2>Weboldal törlése</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    ask_del($ve_id);

 //finally delete vhost
 } elseif ($mode=="finaldel" && nonzero($ve_id)) {
    echo '<h2>Weboldal törlése</h2>';

    check_form_validator();

    if (!(check_vhost($ve_id))) { suicide(); }

    final_del($ve_id);

    closewindow("vhost");

 //ask toggle
 } elseif ($mode=="toggle" && nonzero($ve_id)) {
    echo '<h2>Weboldal ki-bekapcsolása</h2>';

    if (!(check_vhost($ve_id))) { suicide(); }

    ask_toggle_vhost($ve_id);

 //toggle on-off
 } elseif ($mode=="finaltoggle" && nonzero($ve_id)) {
    echo '<h2>Weboldal ki-bekapcsolása</h2>';

    check_form_validator();

    if (!(check_vhost($ve_id))) { suicide(); }

    toggle_vhost($ve_id);

    closewindow("vhost");

 } else {
    echo '<h4>Hibás paraméterezés.</h4>';
    pageclose();
    die();
 }

    DBclose();
    pageclose();
    exit (0);

}
