<?php

function insert_vhost($ve_domid, $ve_host, $ve_alias, $ve_extalias, $ve_docroot, $ve_redirect, $ve_redirect_permanent, $ve_usid) {

    global $CONFIG;

    $node=get_node_domain($ve_domid,true);

    //$vhostname=get_vhost($vhostid);

    $vi_alias=nullquote($ve_alias);
    $vi_extalias=nullquote($ve_extalias);
    $vi_docroot=nullquote($ve_docroot);
    $vi_redirect=nullquote($ve_redirect);
    $vi_redirect_permanent=nullquote($ve_redirect_permanent);

    $vi_writable=nullquote(implode("\n",$CONFIG['def_writable']));

	$token=create_token(32);

    $nsql="INSERT INTO `vhosts` SET `domainid`='$ve_domid', `host`='$ve_host', `alias`=$vi_alias, `ext_alias`=$vi_extalias, `docroot`=$vi_docroot, `redirect`=$vi_redirect, `redirect_permanent`=$vi_redirect_permanent, `writable`=$vi_writable, `upstream`='$ve_usid', `token`='$token'; ";
    check_mysql_query($nsql);
    activate_config('apache_update',$node);
    apply_activation();
    echo "<h4>A weboldalt létrehoztuk.</h4>";
    logme("Vhost created: $ve_host.".get_domain($ve_domid));
}

function update_vhost($vhostid, $ve_alias, $ve_extalias, $ve_docroot, $ve_redirect, $ve_redirect_permanent, $ve_usid, $ve_token) {

    $node=get_node_vhost($vhostid,true);

    $vi_alias=nullquote($ve_alias);
    $vi_extalias=nullquote($ve_extalias);
    $vi_docroot=nullquote($ve_docroot);
    $vi_redirect=nullquote($ve_redirect);
    $vi_redirect_permanent=nullquote($ve_redirect_permanent);

    $update_token='';

	if ($ve_token=="new")
	{
		$token=create_token(32);
		$update_token=",`token`='$token'";
	}

    $usql="UPDATE vhosts SET alias=$vi_alias, ext_alias=$vi_extalias, docroot=$vi_docroot, redirect=$vi_redirect, redirect_permanent=$vi_redirect_permanent, upstream='$ve_usid' ".$update_token." WHERE id='$vhostid';";
    check_mysql_query($usql);
    activate_config('apache_update',$node);
    apply_activation();
    echo "<h4>A weboldalt megváltoztattuk.</h4>";
    logme("Vhost changed: ".get_vhost($vhostid));
}

function update_writabledirs($vhostid, $ve_writable) {

    $node=get_node_vhost($vhostid,true);

    $vi_writable=nullquote($ve_writable);

    $usql="UPDATE `vhosts` SET `writable`=$vi_writable, `rights`=(IF(`rights`=0, 2, IF(`rights`=1, 3, `rights`))) WHERE `id`='$vhostid';";
    check_mysql_query($usql);
    activate_config('apache_update',$node);
    activate_config('rights_update',$node);
    apply_activation();
    echo "<h4>Az írható könyvtárakat és file-okat frissítettük.</h4>";
    logme("Writable dirs changed: ".get_vhost($vhostid));
}

function update_settings($vhostid, $ve_settingsa, $ve_settingsn, $ve_openbasedir) {

	global $adminlogin;

	if ($adminlogin==1)
	{
	    $node=get_node_vhost($vhostid,true);

#		// the original SQL query w/o safety
#	    $vi_settingsa=nullquote($ve_settingsa);
#	    $vi_settingsn=nullquote($ve_settingsn);

#	    $usql="UPDATE vhosts SET `settings`=$vi_settingsa, `nsettings`=$vi_settingsn WHERE id='$vhostid';";
#	    check_mysql_query($usql);

		// do a prepared mysql insert to avoid injection
	    $usql="UPDATE vhosts SET `settings`=?, `nsettings`=?, `extradir`=? WHERE id='$vhostid';";
		$uvalues=array('sss', $ve_settingsa, $ve_settingsn, $ve_openbasedir);
		DBquery_prep($usql, $uvalues);

	    activate_config('apache_update',$node);
	    apply_activation();
	    echo "<h4>A webszerver extra beállításait megváltoztattuk.</h4>";
	    logme("Vhost extra config changed: ".get_vhost($vhostid));
	}
	else
	{
	    echo "<h4>Ehhez a funkcióhoz nincs jogosultsága.</h4>";
	}
}

function update_ssl($vhostid, $ve_ssl_on, $ve_ssl_mode) {

	global $adminlogin;

	if ($adminlogin==1)
	{
		if ($ve_ssl_on) { $ve_ssl_on=1; }
		if ($ve_ssl_mode) { $ve_ssl_mode=1; }

		$node=get_node_vhost($vhostid,true);

		$vsql ="SELECT vhosts.ssl_on AS ssl_on,
				vhosts.ssl_mode AS ssl_mode
			FROM vhosts
			WHERE vhosts.id=\"$vhostid\";";

		$vResult=DBquery($vsql);
		$vRow=$vResult->fetch_assoc();

		if ($ve_ssl_on==1)
		{
			if ($vRow['ssl_on']==4)
			{
				//SSL is working
				if ($vRow['ssl_mode'] != $ve_ssl_mode)
				{
					$usql="UPDATE `vhosts` SET `ssl_mode`='".$ve_ssl_mode."' WHERE id='$vhostid';";
					check_mysql_query($usql);
					activate_config('apache_update',$node);
					apply_activation();
					echo "<h4>A HTTPS üzemmód megváltozott.</h4>";
					logme("SSL mode changed: ".get_vhost($vhostid));
				}
				else
				{
					// Re-scan SSL certs in filesystem
					activate_config('ssl_update',$node);
					activate_config('apache_update',$node);
					apply_activation();
					echo "<h4>Az SSL kulcsok újraellenőrzése folyamatban.</h4>";
					logme("SSL re-scan: ".get_vhost($vhostid));
				}
			}
			else
			{
				//SSL is NOT working yet
				$usql="UPDATE `vhosts` SET `ssl_on`='2' WHERE id='$vhostid';";
				check_mysql_query($usql);
				activate_config('ssl_update',$node);
				apply_activation();
				echo "<h4>Az SSL kulcsok generálása megkezdődött.</h4>";
				logme("SSL requested: ".get_vhost($vhostid));
			}
		}
		else
		{
			if ($vRow['ssl_on']>0)
			{
				// turn off SSL
				$usql="UPDATE `vhosts` SET `ssl_on`=0, `ssl_mode`=0 WHERE id='$vhostid';";
				check_mysql_query($usql);
				activate_config('ssl_update',$node);
				activate_config('apache_update',$node);
				apply_activation();
				echo "<h4>A HTTPS-t kikapcsoltuk.</h4>";
				logme("SSL deactivated: ".get_vhost($vhostid));
			}
			else
			{
				echo "<h4>A HTTPS beállítás nem változott.</h4>";
			}
		}
	}
	else
	{
		echo "<h4>Ehhez a funkcióhoz nincs jogosultsága.</h4>";
	}
}

function toggle_vhost($vhostid) {

    $node=get_node_vhost($vhostid,true);

    $gsql="SELECT active FROM vhosts WHERE id='$vhostid';";
    $gResult=DBquery($gsql);
    $gRow=$gResult->fetch_assoc();
    $active=$gRow['active'];

    if ($active==1) { $setact=0; $kb="ki"; } else { $setact=1; $kb="be"; }

    $tsql="UPDATE vhosts SET active='$setact' WHERE id='$vhostid';";
    check_mysql_query($tsql);
    activate_config('apache_update',$node);
    apply_activation();
    echo "<h4>A weboldalt ".$kb."kapcsoltuk.</h4>";
    logme("Vhost toggle($setact): ".get_vhost($vhostid));
}

function update_rights($vhostid, $mode) {

	$node=get_node_vhost($vhostid,true);
	$vhostname=get_vhost($vhostid);

	if ($mode==1)
	{
		$rights=3;
	}
	else
	{
		$rights=2;
	}

	$dsql="UPDATE vhosts SET `rights`='".$rights."' WHERE id='$vhostid';";
	check_mysql_query($dsql);
	activate_config('rights_update',$node);
	apply_activation();
	if ($rights==3)
	{
		echo "<h4>A malware védelmet <b>felfüggesztettük</b> a(z) $vhostname weboldalon. Minden file és könyvtár írható.</h4>";
		logme("FS Protection suspended: $vhostname");
	}
	else
	{
		echo "<h4>A malware védelmet <b>aktiváltuk</b> a(z) $vhostname weboldalon.</h4>";
		logme("FS Protection activated: $vhostname");
	}
}

/*
function final_rightsfix($vhostid) {

    $node=get_node_vhost($vhostid,true);
    $vhostname=get_vhost($vhostid);

    $dsql="UPDATE vhosts SET `rights`=2 WHERE id='$vhostid';";
    check_mysql_query($dsql);
    activate_config('rights_update',$node);
    apply_activation();
    echo "<h4>A védelmet <b>aktiváltuk</b> a(z) $vhostname weboldalon.</h4>";
    logme("FS Protection activated: $vhostname");
}

function final_rightswr($vhostid) {

    $node=get_node_vhost($vhostid,true);
    $vhostname=get_vhost($vhostid);

    $dsql="UPDATE vhosts SET `rights`=3 WHERE id='$vhostid';";
    check_mysql_query($dsql);
    activate_config('rights_update',$node);
    apply_activation();
    echo "<h4>A védelmet <b>felfüggesztettük</b> a(z) $vhostname weboldalon. Minden file és könyvtár írható.</h4>";
    logme("FS Protection suspended: $vhostname");
}
*/

function final_del($vhostid) {

    $node=get_node_vhost($vhostid,true);
    $vhostname=get_vhost($vhostid);

	// deploy
    $dsql="DELETE FROM `deploy` WHERE `vhostid`='$vhostid';";
    check_mysql_query($dsql);

	//vhost
    $dsql="DELETE FROM `vhosts` WHERE `id`='$vhostid';";
    check_mysql_query($dsql);

	// vhost stats
	$dssql="DELETE FROM `stats_vhost` WHERE `vhostid`='$vhostid';";
    check_mysql_query($dssql);

    activate_config('apache_update',$node);
    activate_config('ssl_update',$node);
    apply_activation();
    echo "<h4>A weboldalt töröltük.</h4>";
    logme("Vhost deleted: $vhostname");
}

/*
function activate_vhost_config($node=NULL) {
    if (!(is_null($node))) {
	if ($node==0)
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='apache_update';";
	} else
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='apache_update' AND `node`='$node';";
	}
	check_mysql_query($asql);
    }
}

function activate_rights($node=NULL) {
    if (!(is_null($node))) {
	if ($node==0)
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='rights_update';";
	} else
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='rights_update' AND `node`='$node';";
	}
	check_mysql_query($asql);
    }
}

function activate_domain_config($node=NULL) {
    if (!(is_null($node))) {
	if ($node==0)
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='bind_update';";
	} else
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='bind_update' AND `node`='$node';";
	}
	check_mysql_query($asql);
    }
}

function activate_mysql_config($node=NULL) {
    if (!(is_null($node))) {
	if ($node==0)
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='mysql_update';";
	} else
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='mysql_update' AND `node`='$node';";
	}
	check_mysql_query($asql);
    }
}

function activate_ssl_gen($node=NULL) {
    if (!(is_null($node))) {
	if ($node==0)
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='ssl_update';";
	} else
	{
	    $asql="UPDATE var SET `value`=1 WHERE `key`='ssl_update' AND `node`='$node';";
	}
	check_mysql_query($asql);
    }
}
*/
