<?php

### main function

function get_sql($query,$rowname) {

    $sqlResult=DBquery($query);
    if ($sqlResult->num_rows == 1)
    {
	$sqlRow=$sqlResult->fetch_assoc();

	$result=$sqlRow[$rowname];
	return $result;
    }
    else
    {
	return null;
    }
}

### special functions

function get_pending($key) {
    $ksql="SELECT `value`, `lock` FROM `var` WHERE `key`='$key';";
    $kResult=DBquery($ksql);
    while ($kRow=$kResult->fetch_assoc()) {
	if ($kRow['value']==1 || $kRow['lock']==1) { return true; }
    }
    return false;
}

//get all client data
function get_client_data($clid) {

	$clisql ="SELECT *
		FROM client
		WHERE id='$clid' ;";

	$cliResult=DBquery($clisql);
	return $cliResult->fetch_assoc();
}

function get_client($clid) {

    $clisql ="SELECT name
	    FROM client
    	    WHERE id='$clid' ;";

    $clilogin=get_sql($clisql,'name');
    return $clilogin;
}


function get_clientid($cliname) {

    $clisql ="SELECT id
	    FROM client
    	    WHERE name='$cliname' ;";

    return get_sql($clisql,'id');
}

function get_clientpass($clid) {

    $clisql ="SELECT password AS pass
	    FROM client
    	    WHERE id='$clid' ;";

    $clipass=get_sql($clisql,'pass');
    return $clipass;
}

function get_quota($clid) {

    $qsql ="SELECT quota
	    FROM client
    	    WHERE id='$clid' ;";

    $cliq=get_sql($qsql,'quota');
    return $cliq;
}

function get_mailquota($clid) {

    $mqsql ="SELECT mailquota
			FROM client
			WHERE id='$clid' ;";

    $climq=get_sql($mqsql,'mailquota');
    return $climq;
}

function get_quota_ftp($ftpid) {

    $qsql ="SELECT client.quota AS quota
	    FROM cli_ftp
	    LEFT JOIN client ON cli_ftp.clientid=client.id
    	    WHERE cli_ftp.id='$ftpid' ;";

    $maxq=get_sql($qsql,'quota');
    return $maxq;
}

function get_quota_domain($domainid) {

    $qsql ="SELECT client.quota AS quota
	    FROM domain
	    LEFT JOIN client ON domain.clientid=client.id
    	    WHERE domain.id='$domainid' ;";

    $maxq=get_sql($qsql,'quota');
    return $maxq;
}

function get_quota_mailbox($mailboxid) {

    $qsql ="SELECT client.quota AS quota
	    FROM mail_users
	    LEFT JOIN domain ON mail_users.domain=domain.id
	    LEFT JOIN client ON domain.clientid=client.id
    	    WHERE mail_users.id='$mailboxid' ;";

    $maxq=get_sql($qsql,'quota');
    return $maxq;
}

//get all domain data
function get_domain_data($domainid) {

    $dsql ="SELECT * FROM domain
    		WHERE id='$domainid' ;";

    $dResult=DBquery($dsql);
    $dRow=$dResult->fetch_assoc();

    $dRow['uniname']=domuni($dRow['name']);
    $dRow['uniname_html']=domuni($dRow['name'],"<span class=\"red\">","</span>");

    return $dRow;
}

// get domain name for id
function get_domain($domainid) {

    $dsql ="SELECT name FROM domain
    	    WHERE id='$domainid' ;";

    $dResult=DBquery($dsql);
    $dRow=$dResult->fetch_assoc();

    $domain=domuni($dRow['name'],"<span class=\"red\">","</span>");

    return $domain;

}

function get_domainid($domain) {

    $dsql ="SELECT `id` FROM `domain`
    	    WHERE `name`='$domain' ;";

    return get_sql($dsql,'id');
}

// get all host data
function get_host_data($hid) {

    $hsql ="SELECT *
	    FROM dom_host
    	    WHERE id='$hid' ;";

    $hResult=DBquery($hsql);
    return $hResult->fetch_assoc();
}

// get hostname for id
function get_host($hid) {

    $hsql ="SELECT dom_host.host AS host, domain.name AS domname
	    FROM dom_host
	    LEFT JOIN domain ON dom_host.domainid=domain.id
    	    WHERE dom_host.id='$hid' ;";

    $hResult=DBquery($hsql);
    $hRow=$hResult->fetch_assoc();

    $domain=domuni($hRow['domname'],"<span class=\"red\">","</span>");
    
    return $hRow['host'].".".$domain;
}

// get domain id for host id
function get_host_domainid($hid) {

    $hsql ="SELECT domainid
	    FROM dom_host
    	WHERE dom_host.id='$hid' ;";

    $hResult=DBquery($hsql);
    $hRow=$hResult->fetch_assoc();
    
    return $hRow['domainid'];
}

function get_hostid($hostname, $domid) {

	$hsql="SELECT dom_host.id AS id FROM dom_host
		LEFT JOIN domain ON dom_host.domainid=domain.id
		WHERE domain.id='$domid'
		AND dom_host.host='$hostname'; ";
    return get_sql($hsql,'id');
}

//get all domrec data
function get_domrec_data($rid)
{
    $rsql ="SELECT *
	    FROM dom_records
    	    WHERE id='$rid' ;";
    $rResult=DBquery($rsql);
    return $rResult->fetch_assoc();
}

// get recordname for DNS record
function get_domrec($rid) {

    $hsql ="SELECT dom_records.host AS host, domain.name AS domname
	    FROM dom_records
	    LEFT JOIN domain ON dom_records.domainid=domain.id
    	    WHERE dom_records.id='$rid' ;";

    $hResult=DBquery($hsql);
    $hRow=$hResult->fetch_assoc();

    $domain=domuni($hRow['domname'],"<span class=\"red\">","</span>");
    
    if ($hRow['host']=="@")
    {
	$ret=$hRow['host']." (".$domain.")";
    } else 
    {
	$ret=$hRow['host'].".".$domain;
    }

    return $ret;
}

// get record type for DNS record
function get_domrec_type($rid) {

    $hsql ="SELECT type FROM dom_records WHERE id='$rid' ;";

    $rectype=get_sql($hsql,'type');
    return $rectype;
}

function get_fqdn($hostid, $domainid) {
    if ($hostid>0) {
	$fqdn=get_host($hostid);
    } else {
	$fqdn=get_domain($domainid);
    }
    return $fqdn;
}

// get domain id for record id
function get_domrec_domainid($rid) {

    $hsql ="SELECT domainid
	    FROM dom_records
   	    WHERE dom_records.id='$rid' ;";

    $hResult=DBquery($hsql);
    $hRow=$hResult->fetch_assoc();

    return $hRow['domainid'];

}

//get all mailbox data
function get_mailbox_data($mailboxid)
{
    $mbsql ="SELECT *
	    FROM mail_users
    	    WHERE id='$mailboxid' ;";

    $mbResult=DBquery($mbsql);
    return $mbResult->fetch_assoc();
}

// get e-mail address for mailbox ID
function get_mailbox($mailboxid) {

    $mbsql ="SELECT mail_users.name AS name, domain.name AS domain, dom_host.host AS host
	    FROM mail_users
	    LEFT JOIN domain ON mail_users.domainid=domain.id
	    LEFT JOIN dom_host ON mail_users.hostid=dom_host.id
    	    WHERE mail_users.id='$mailboxid' ;";

    $mbResult=DBquery($mbsql);
    $mbRow=$mbResult->fetch_assoc();


    $domain=domuni($mbRow['domain'],"<span class=\"red\">","</span>");

    $email=$mbRow['name'].'@';
    if ($mbRow['host']) { $email.=$mbRow['host'].'.'; }
    $email.=$domain;

    return $email;

}
// get e-mail username for mailbox id
function get_mailbox_userpart($mailboxid) {

    $mbsql ="SELECT name
	    FROM mail_users
    	    WHERE id='$mailboxid' ;";

    $mbup=get_sql($mbsql,'name');
    return $mbup;
}

// get e-mail password for mailbox id
function get_mailboxpass($mailboxid) {

    $mbsql ="SELECT `password`
	    FROM `mail_users`
		WHERE `id`='$mailboxid' ;";

    $mbpass=get_sql($mbsql,'password');
    return $mbpass;
}

//get all alias data
function get_alias_data($aliasid)
{
    $asql ="SELECT *
	    FROM mail_aliases
    	    WHERE id='$aliasid' ;";

    $aResult=DBquery($asql);
    return $aResult->fetch_assoc();
}


// get alias for alias ID
function get_alias($aliasid) {

    $mbsql ="SELECT mail_aliases.alias AS alias, domain.name AS domain, dom_host.host AS host
	    FROM mail_aliases
	    LEFT JOIN domain ON mail_aliases.domainid=domain.id
	    LEFT JOIN dom_host ON mail_aliases.hostid=dom_host.id
    	    WHERE mail_aliases.id='$aliasid' ;";

    $mbResult=DBquery($mbsql);
    $mbRow=$mbResult->fetch_assoc();

    $domain=domuni($mbRow['domain'],"<span class=\"red\">","</span>");

    $aliasemail=$mbRow['alias'].'@';
    if ($mbRow['host']) { $aliasemail.=$mbRow['host'].'.'; }
    $aliasemail.=$domain;

    return $aliasemail;

}

//get all ftp data
function get_ftp_data($ftpid)
{
	$ftpsql ="SELECT *
		FROM cli_ftp
		WHERE id='$ftpid' ;";
	$ftpResult=DBquery($ftpsql);
	return $ftpResult->fetch_assoc();
}

// get ftp login for FTP id
function get_ftp($ftpid) {

    $ftpsql ="SELECT CONCAT(client.name,'.',cli_ftp.name) AS login
	    FROM cli_ftp
	    LEFT JOIN client ON cli_ftp.clientid=client.id
    	    WHERE cli_ftp.id='$ftpid' ;";

    $ftplogin=get_sql($ftpsql,'login');
    return $ftplogin;
}
// get ftp login userpart for FTP id
function get_ftp_userpart($ftpid) {

    $ftpsql ="SELECT name
	    FROM cli_ftp
    	    WHERE id='$ftpid' ;";

    $ftplogin=get_sql($ftpsql,'name');
    return $ftplogin;
}
// get ftp password for FTP id
function get_ftppass($ftpid) {

    $ftppsql ="SELECT cli_ftp.password AS pass
	    FROM cli_ftp
	    LEFT JOIN client ON cli_ftp.clientid=client.id
    	    WHERE cli_ftp.id='$ftpid' ;";

    $ftppass=get_sql($ftppsql,'pass');
    return $ftppass;
}

//get all mysql data
function get_mysql_data($sqlid)
{
	$sqlsql ="SELECT *
		FROM mysql
		WHERE id='$sqlid' ;";
	$sqlResult=DBquery($sqlsql);
	return $sqlResult->fetch_assoc();
}

//get mysql name
function get_mysql($sqlid) {

    $sqlsql ="SELECT clientid, name
	    FROM mysql
    	    WHERE id='$sqlid';";

    $sqlResult=DBquery($sqlsql);
    $sqlRow=$sqlResult->fetch_assoc();


    $sqllogin=cli_pad($sqlRow['clientid'])."_".$sqlRow['name'];
    return $sqllogin;
}
//get mysql userpart
function get_mysql_userpart($sqlid) {

    $sqlsql ="SELECT name
	    FROM mysql
    	    WHERE id='$sqlid';";

    $sqllogin=get_sql($sqlsql,'name');
    return $sqllogin;
}
//get mysql password
function get_mysqlpass($sqlid) {

    $sqlsql ="SELECT password AS pass
	    FROM mysql
    	    WHERE id='$sqlid';";

    $sqlResult=DBquery($sqlsql);
    $sqlRow=$sqlResult->fetch_assoc();

    $sqlpass=get_sql($sqlsql,'pass');
    return $sqlpass;
}

//get all vhost data
function get_vhost_data($vhostid)
{
	$vhsql ="SELECT *
		FROM vhosts
		WHERE id='$vhostid' ;";
	$vhResult=DBquery($vhsql);
	return $vhResult->fetch_assoc();
}

function get_vhost($vhostid) {

    $vhsql ="SELECT CONCAT(vhosts.host,'.',domain.name) AS hostname
	    FROM vhosts
	    LEFT JOIN domain ON vhosts.domainid=domain.id
    	    WHERE vhosts.id='$vhostid' ;";

    $vhname=get_sql($vhsql,'hostname');
    return $vhname;
}

function get_deploy_vhost($deployid) {

    $dvhsql ="SELECT CONCAT(vhosts.host,'.',domain.name) AS hostname
	    FROM deploy
		LEFT JOIN vhosts ON deploy.vhostid=vhosts.id
	    LEFT JOIN domain ON vhosts.domainid=domain.id
    	    WHERE deploy.id='$deployid' ;";

    $vhname=get_sql($dvhsql,'hostname');
    return $vhname;
}

function get_deploy_vhostid($deployid) {

    $dvhsql ="SELECT `vhosts`.`id` AS vhid
	    FROM `deploy`
		LEFT JOIN `vhosts` ON `deploy`.`vhostid`=`vhosts`.`id`
		WHERE `deploy`.`id`='$deployid' ;";

    $vhid=get_sql($dvhsql,'vhid');
    return $vhid;
}

function get_vhost_deployid($vhid) {

    $dvhsql ="SELECT `deploy`.`id` AS deployid
	    FROM `vhosts`
		LEFT JOIN `deploy` ON `deploy`.`vhostid`=`vhosts`.`id`
		WHERE `vhosts`.`id`='$vhid' ;";

    $did=get_sql($dvhsql,'deployid');
    return $did;
}

function get_vhost_ssl($vhid) {

	$vhssql ="SELECT IF(`ssl_on`=4,1,0) AS `ssl`
		FROM `vhosts`
		WHERE `id`='$vhid' ;";

	$vhssl=get_sql($vhssql,'ssl');
	return $vhssl;
}

# node

function get_node_client($clientid,$mig=false) {

    if ($mig==false) { $nsel ="node"; } else { $nsel ="IF(migrate=1, 0, node)"; }

    if ($clientid>0) {
	$nsql ="SELECT $nsel AS node FROM client
    	    WHERE client.id='$clientid';";
	$node=get_sql($nsql,'node');
    } else {
	$node=1;
    }
    return $node;
}

function get_node_mysql($mysqlid,$mig=false) {

    if ($mig==false) { $nsel ="client.node"; } else { $nsel ="IF(client.migrate=1, 0, client.node)"; }

    $nsql ="SELECT $nsel AS node
	    FROM mysql
	    LEFT JOIN client ON mysql.clientid=client.id
    	    WHERE mysql.id='$mysqlid' ;";

    $node=get_sql($nsql,'node');
    return $node;
}

function get_node_cliftp($cliftpid,$mig=false) {

    if ($mig==false) { $nsel ="client.node"; } else { $nsel ="IF(client.migrate=1, 0, client.node)"; }

    $nsql ="SELECT $nsel AS node
	    FROM cli_ftp
	    LEFT JOIN client ON cli_ftp.clientid=client.id
    	    WHERE cli_ftp.id='$cliftpid' ;";
    $node=get_sql($nsql,'node');
    return $node;
}

function get_node_domain($domid,$mig=false) {

    if ($mig==false) { $nsel ="client.node"; } else { $nsel ="IF(client.migrate=1, 0, client.node)"; }

    $nsql ="SELECT $nsel AS node
	    FROM domain
	    LEFT JOIN client ON domain.clientid=client.id
    	    WHERE domain.id='$domid' ;";
    $node=get_sql($nsql,'node');
    return $node;
}

function get_node_vhost($vhid,$mig=false) {

    if ($mig==false) { $nsel ="client.node"; } else { $nsel ="IF(client.migrate=1, 0, client.node)"; }

    $nsql ="SELECT $nsel AS node
	    FROM vhosts
	    LEFT JOIN domain ON vhosts.domainid=domain.id
	    LEFT JOIN client ON domain.clientid=client.id
    	    WHERE vhosts.id='$vhid' ;";
    $node=get_sql($nsql,'node');
    return $node;
}

function get_node_deploy($deployid,$mig=false) {

    if ($mig==false) { $nsel ="client.node"; } else { $nsel ="IF(client.migrate=1, 0, client.node)"; }

    $nsql ="SELECT $nsel AS node
	    FROM deploy
		LEFT JOIN vhosts ON deploy.vhostid=vhosts.id
	    LEFT JOIN domain ON vhosts.domainid=domain.id
	    LEFT JOIN client ON domain.clientid=client.id
    	    WHERE deploy.id='$deployid' ;";
    $node=get_sql($nsql,'node');
    return $node;
}

function get_domain_cliid($domainid) {

    $cdsql ="SELECT clientid
			FROM domain
			WHERE id='$domainid';";

    $cliid=get_sql($cdsql,'clientid');
    return $cliid;
}

function get_mailbox_cliid($mbid) {

    $cmbsql ="SELECT `domain`.`clientid` AS `clientid`
			FROM `mail_users`
			LEFT JOIN `domain` ON `mail_users`.`domainid`=`domain`.`id`
			WHERE `mail_users`.`id`='$mbid';";

    $cliid=get_sql($cmbsql,'clientid');
    return $cliid;
}

?>