<?php

function do_import($csvformat, $csv_arr)
{

	global $adminlogin;
	global $clientid;

	$i_count=0;
	$csv_count=count($csv_arr);

	//start transaction
	DBquery("SET autocommit = 0;");
	DBquery("START TRANSACTION;");

	$stmt=DBpq_prepare("INSERT INTO `mail_aliases` SET `domainid`=?, `hostid`=?, `alias`=?, `goto`=?, `active`=1, `modified`=NOW();");

	foreach($csv_arr as $line_no => $in_line)
	{
		//$csvformat="alias_név;[host/aldomain];domain;cél_1,...";
		$i_alias=strtolower($in_line[0]);
		$i_host=strtolower($in_line[1]);
		$i_domain=strtolower($in_line[2]);
		$i_goto=csvl2multirow(strtolower($in_line[3]),',');

		$i_unidomain=unidom($i_domain);

		$no_dupe=true;

		if
		(
			($in_line[0]!="<DUPLIKÁLT>") &&
			check_clean_array(array($i_domain,$i_unidomain,$i_host)) &&
			mand_str($i_domain, 'Domainnév', false) &&
			check_format_domain($i_domain, false, false) &&
			(($d_domainid=get_domainid($i_unidomain))>0) &&
			(!$i_host || check_format_host($i_host, false)) &&
			(!$i_host || ($d_hostid=get_hostid($i_host, $d_domainid))>0)
		)
		{
			if (!$i_host) { $d_hostid=NULL; }

			if
			(
				check_clean_array(array($i_alias, $i_goto)) &&

				mand_str($i_alias, 'Alias név', false) &&
				check_format_alnum_ext($i_alias, 'Alias név', false) &&
				($no_dupe=check_exist_mailalias($i_alias, $d_domainid, $d_hostid, false)) &&

				mand_str($i_goto, 'A cél', false) &&
				check_format_multirow_email($i_goto, false)

			)
			{
				null_if_false($d_hostid);

				$i_alias=str_replace('*','',$i_alias);

				// here we do the import
				//`mail_aliases` SET `domainid`=?, `hostid`=?, `alias`=?, `goto`=?, `active`=1, `modified`=NOW();
				$nvalues=array('iiss', $d_domainid, $d_hostid, $i_alias, $i_goto);
				DBpq_execute($stmt, $nvalues);

				$i_count++;
				unset($csv_arr[$line_no]);

				logme("Alias imported: ".$i_alias."@".gen_fqdn($i_host, $i_domain));
			}
			elseif(!$no_dupe)
			{
				//unset($csv_arr[$line_no]);
				array_unshift($csv_arr[$line_no],"<DUPLIKÁLT>");
			}
		}
	}

	DBpq_close($stmt);

	// commit transaction
	DBquery("COMMIT;");
	DBquery("SET autocommit = 1;");

	if ($i_count>0)
	{
		echo "<h4>Sikeresen importálva $i_count alias cím (összesen: $csv_count).</h4><br />";
	}
	else
	{
		echo "<h4>Sikertelen importálás.</h4><br />";
	}
	return ($csv_arr);
}
