<?php

function do_import($csvformat, $csv_arr)
{

	$i_count=0;
	$csv_count=count($csv_arr);

	//start transaction
	DBquery("SET autocommit = 0;");
	DBquery("START TRANSACTION;");

	$stmt=DBpq_prepare("INSERT INTO `client` SET `name`=?, `password`=?, `email`=?, `quota`=?, `mailquota`=?, `node`=? ;");

	foreach($csv_arr as $line_no => $in_line)
	{
		//$csvformat="ügyfélnév;[jelszó];admin_email;webtárhely_mb;mailtárhely_mb;[szerver#]";
		$i_name=strtolower($in_line[0]);
		$i_password=$in_line[1];
		$i_email=strtolower($in_line[2]);
		$i_quota=$in_line[3];
		$i_mailquota=$in_line[4];
		$i_node=$in_line[5];

		$no_dupe=true;

		if
		(
			($in_line[0]!="<DUPLIKÁLT>") &&
			check_clean_array(array($i_name, $i_password, $i_email, $i_quota, $i_mailquota, $i_node)) &&

			mand_str($i_name, 'Ügyfél neve', false) &&
			check_format_alnum($i_name, 'ügyfélnév', false) &&
			($no_dupe=check_exist_client($i_name, false)) &&

			opt_pass($i_password, $i_password, $i_name, '', 1, false) &&

			mand_str($i_email, 'admin e-mail', false) &&
			check_format_email($i_email, false) &&

			mand_int($i_quota,'Tárhely', false) &&
			mand_int_positive($i_mailquota,'E-mail tárhely', false) &&

			check_node($i_node, false)
		)
		{
			$d_newpass=gen_pass($i_password, false);
			if (!(is_numeric($i_node))) { $i_node=1; }

			// here we do the import
			//`name`=?, `password`=?, `email`=?, `quota`=?, `mailquota`=?, `node`=?
			$nvalues=array('sssiii', $i_name, $d_newpass, $i_email, $i_quota, $i_mailquota, $i_node);
			DBpq_execute($stmt, $nvalues);

			$i_count++;
			unset($csv_arr[$line_no]);
			logme("Client imported: $i_name, node: $i_node, email: $i_email, quota:$i_quota, mailquota:$i_mailquota");
		}
		elseif(!$no_dupe)
		{
			array_unshift($csv_arr[$line_no],"<DUPLIKÁLT>");
		}

	}

	DBpq_close($stmt);

	// commit transaction
	DBquery("COMMIT;");
	DBquery("SET autocommit = 1;");

	if ($i_count>0)
	{
		echo "<h4>Sikeresen importálva $i_count felhasználó (összesen: $csv_count).</h4><br />";

		activate_config('mysql_update', $i_node);
		apply_activation();
	}
	else
	{
		echo "<h4>Sikertelen importálás.</h4><br />";
	}
	return ($csv_arr);
}
