<?php

function do_import($csvformat, $csv_arr)
{

	global $adminlogin;
	global $clientid;

	$i_count=0;
	$csv_count=count($csv_arr);

	//start transaction
	DBquery("SET autocommit = 0;");
	DBquery("START TRANSACTION;");

	$stmt=DBpq_prepare("INSERT INTO `domain` SET `clientid`=?, `name`=?, `dns`=?, `ip`=?, `mx`=?, `spf`=?, `dmarc`=?, `modified`=NOW();");

	foreach($csv_arr as $line_no => $in_line)
	{
		//$csvformat="ügyfélnév;domainnév;dns_aktív;levelezés_aktív;[elsődleges_ip];[mx_rekord];[spf_extra];[dmarc]";
		$i_client=strtolower($in_line[0]);
		$i_name=strtolower($in_line[1]);
		$i_dns=$in_line[2];
		$i_mxon=$in_line[3];
		$i_ip=$in_line[4];
		$i_mx=csvl2multirow(strtolower($in_line[5]), ',');
		$i_spf=strtolower($in_line[6]);
		$i_dmarc=strtolower($in_line[7]);

		$i_uniname=unidom($i_name);

		$no_dupe=true;

		if
		(
			($in_line[0]!="<DUPLIKÁLT>") &&
			check_clean($i_client) && 
			mand_str($i_client, 'Ügyfél neve', false) &&
			check_format_alnum($i_client, 'ügyfélnév', false) &&
			(($d_clientid=get_clientid($i_client))>0)
		)
		{
			if
			(
				check_clean_array(array($i_name, $i_uniname, $i_dns, $i_mxon, $i_ip, $i_mx)) &&

				mand_str($i_name, 'Domainnév', false) &&
				check_format_domain($i_name, true, false) &&
				($no_dupe=check_exist_domain($i_uniname, false)) &&

				mand_int($i_dns, 'DNS', false) &&
				mand_int($i_mxon, 'MX', false) &&
				(!$i_ip || check_format_ip($i_ip, false)) &&
				(!$i_mx || check_format_multirow_mx($i_mx, false)) &&
				(!$i_spf || check_format_spf($i_spf, false)) &&
				(!$i_dmarc || check_format_dmarc($i_dmarc, false))
			)
			// not checking if domain is already registered
			// ((($i_dns == 0) && ($i_mxon == 0)) || (check_registered_domain($i_uniname, true)))
			{

				if ($i_mxon==1) { $i_mx=NULL;}
				if ($i_mxon==0 && !$i_mx) { $i_mx='';}

				null_if_false($i_ip);
				null_if_false($i_spf);
				null_if_false($i_dmarc);

				// here we do the import
				// `clientid`=?, `name`=?, `dns`=?, `ip`=?, `mx`=?, `spf`=?, `modified`=NOW();
				$nvalues=array('isissss', $d_clientid, $i_uniname, $i_dns, $i_ip, $i_mx, $i_spf, $i_dmarc);
				DBpq_execute($stmt, $nvalues);

				$i_count++;
				unset($csv_arr[$line_no]);
				logme("Domain imported: $i_name.");
			}
			elseif(!$no_dupe)
			{
				array_unshift($csv_arr[$line_no],"<DUPLIKÁLT>");
			}
		}
	}

	DBpq_close($stmt);

	// commit transaction
	DBquery("COMMIT;");
	DBquery("SET autocommit = 1;");

	if ($i_count>0)
	{
		echo "<h4>Sikeresen importálva $i_count domain (összesen: $csv_count).</h4><br />";

		activate_config('bind_update');
		activate_config('opendkim_update');
		apply_activation();
	}
	else
	{
		echo "<h4>Sikertelen importálás.</h4><br />";
	}
	return ($csv_arr);
}
