<?php

function do_import($csvformat, $csv_arr)
{

	global $adminlogin;
	global $clientid;

	$i_count=0;
	$csv_count=count($csv_arr);

	//start transaction
	DBquery("SET autocommit = 0;");
	DBquery("START TRANSACTION;");

	$stmt=DBpq_prepare("INSERT INTO `dom_host` SET `domainid`=?, `host`=?, `ip`=?, `mx`=?, `modified`=NOW();");

	foreach($csv_arr as $line_no => $in_line)
	{
		//$csvformat="domainnév;aldomain;levelezés_aktív;[elsődleges_ip];[mx1,...]";
		$i_domain=strtolower($in_line[0]);
		$i_hostname=strtolower($in_line[1]);
		$i_mxon=$in_line[2];
		$i_ip=$in_line[3];
		$i_mx=csvl2multirow(strtolower($in_line[4]), ',');

		$i_unidomain=unidom($i_domain);

		$no_dupe=true;

		if
		(
			($in_line[0]!="<DUPLIKÁLT>") &&
			check_clean_array(array($i_domain,$i_unidomain)) &&
			mand_str($i_domain, 'Domainnév', false) &&
			check_format_domain($i_domain, false, false) &&
			(($d_domainid=get_domainid($i_unidomain))>0)
		)
		{
			if
			(
				check_clean_array(array($i_hostname, $i_mxon, $i_ip, $i_mx)) &&

				mand_str($i_hostname, 'Aldomain', false) &&
				check_format_host($i_hostname, false) &&
				($no_dupe=check_exist_host($i_hostname, $d_domainid, false)) &&

				mand_int($i_mxon, 'MX', false) &&
				(!$i_ip || check_format_ip($i_ip, false)) &&
				(!$i_mx || check_format_multirow_mx($i_mx, false))
			)
			{

				if ($i_mxon==1) { $i_mx=NULL; }
				if ($i_mxon==0 && !$i_mx) { $i_mx=''; }

				null_if_false($i_ip);

				// here we do the import
				// `domainid`=?, `host`=?, `ip`=?, `mx`=?, `modified`=NOW();");
				$nvalues=array('isss', $d_domainid, $i_hostname, $i_ip, $i_mx);
				DBpq_execute($stmt, $nvalues);

				$i_count++;
				unset($csv_arr[$line_no]);
				logme("Subdomain imported: $i_hostname.$i_domain");
			}
			elseif (!$no_dupe)
			{
				array_unshift($csv_arr[$line_no],"<DUPLIKÁLT>");
			}
		}
	}

	DBpq_close($stmt);

	// commit transaction
	DBquery("COMMIT;");
	DBquery("SET autocommit = 1;");

	if ($i_count>0)
	{
		echo "<h4>Sikeresen importálva $i_count aldomain (összesen: $csv_count).</h4><br />";

		activate_config('bind_update');
		activate_config('opendkim_update');
		apply_activation();
	}
	else
	{
		echo "<h4>Sikertelen importálás.</h4><br />";
	}
	return ($csv_arr);
}
