<?php

function admin_required($msg)
{
	global $adminlogin;
	global $clientid;
	
	if ($adminlogin!=1)
	{
		echo "<h4>Új $msg importálásához nincs jogosultsága.</h4>\n";
		DBclose();
		pageclose();
		die(0);
	}
	return 0;
}


function import_route($func, $mode, $csvformat, $csvhelp, $csvdata)
{
	global $CONFIG;
	global $adminlogin;
	global $clientid;

	require $CONFIG['adir'].'/include/import/forms.php';

	if ($mode=='edit')
	{
		edit_import($func, $csvformat, $csvhelp, $csvdata);
	}
	elseif($mode=='save')
	{
		check_form_validator();
		$csv_field_count=count(explode(';',$csvformat));
		$csv_item_tpl=array_fill(0,$csv_field_count, NULL);

		$csv_arr=array();
		foreach((explode("\n", preg_replace("/\n\r/", "\n", $csvdata))) as $csv_line)
		{
			if (strlen(trim($csv_line))>0)
			{
#				$csv_arr[]=str_getcsv($csv_line, ";");
				$csv_arr[]=array_replace($csv_item_tpl,str_getcsv($csv_line, ";"));
			}
		}

		if (count($csv_arr)<1)
		{
			echo '<h4>Üres CSV.</h4>';
			edit_import($func, $csvformat, $csvhelp, $csvdata);
			exit(0);
		}

		require $CONFIG['adir'].'/include/import/'.$func.'/functions.php';

		$remain_arr=do_import($csvformat, $csv_arr);

		if (count($remain_arr)>0)
		{
			$remain_data="";
			foreach ($remain_arr as $remain_row)
			{
				$remain_data.=implode(';', $remain_row)."\n";
			}
			refreshmainwindow("$func");
			edit_import($func, $csvformat, $csvhelp, $remain_data);
		}
		else
		{
		    closewindow("$func");
		}
	}
	else
	{
		echo '<h4>Hibás paraméterezés.</h4>';
		DBclose();
		pageclose();
		die();
	}
}

#################################################################### MAIN

function startmain()
{
	htmlheader();

	global $CONFIG;
	global $adminlogin;
	global $clientid;

	global $mainfunc;

	// get mode
	$mode=gp_str('mode');
	$csvdata=gp_raw('csv');

	// import client
	if ($mainfunc == 'client')
	{
		admin_required('ügyfél');
		echo '<h2>Ügyfelek importálása</h2>';

		$csvformat="ügyfélnév;[\"jelszó\"];admin_email;webtárhely_mb;mailtárhely_mb;[szerver#]";
		$csvhelp="";

		import_route('client', $mode, $csvformat, $csvhelp, $csvdata);
	}
	elseif ($mainfunc == 'domain')
	{
		admin_required('domain');
		echo '<h2>Domainek importálása</h2>';

		$csvformat="ügyfélnév;domainnév;dns_aktív;levelezés_aktív;[elsődleges_ip];[mx1,...];[\"spf_extra\"];[\"dmarc\"]";
		$csvhelp="dns_aktív:1/0, levelezés_aktív:1/0";

		import_route('domain', $mode, $csvformat, $csvhelp, $csvdata);
	}
	elseif ($mainfunc == 'host')
	{
		admin_required('host');
		echo '<h2>Aldomainek importálása</h2>';

		$csvformat="domainnév;aldomain;levelezés_aktív;[elsődleges_ip];[mx1,...]";
		$csvhelp="levelezés_aktív:1/0";

		import_route('host', $mode, $csvformat, $csvhelp, $csvdata);
	}
	elseif ($mainfunc == 'vhost')
	{
		admin_required('vhost');
		echo '<h2>Weboldalak importálása</h2>';

		//$csvformat="domain;host;[alias1,...];[külső_alias1,...];[index_root];[átirányítás];[írható_dir1,...];[engine]";
		$csvformat="domain;host;[alias1,...];[külső_alias1,...];[index_root];[\"átirányítás\"];[átir_permanens];[írható_dir1,...];[engine];[extra_dir1,...];[https];[csak_https];[\"apache_cfg_base64\"];[\"nginx_cfg_base64\"]";

		require $CONFIG['adir'].'/include/import/vhost/params.php';
		$csvhelp="engine: ".generate_upstream_list();

		import_route('vhost', $mode, $csvformat, $csvhelp, $csvdata);
	}
	elseif ($mainfunc == 'mysql')
	{
		admin_required('mysql');
		echo '<h2>Adatbázisok importálása</h2>';

		$csvformat="ügyfélnév;adatbázisnév;[\"jelszó\"]";
		$csvhelp="";

		import_route('mysql', $mode, $csvformat, $csvhelp, $csvdata);
	}
	elseif ($mainfunc == 'mailbox')
	{
		admin_required('mailbox');
		echo '<h2>Postafiókok importálása</h2>';

		$csvformat="felhasználónév;[host/aldomain];domain;[\"jelszó\"];[tárhely_mb]";
		$csvhelp="tárhely_mb <b>&lt;&equals;</b> max_mailtárhely_mb";

		import_route('mailbox', $mode, $csvformat, $csvhelp, $csvdata);
	}
	elseif ($mainfunc == 'alias')
	{
		admin_required('alias');
		echo '<h2>Alias címek importálása</h2>';

		$csvformat="alias_név;[host/aldomain];domain;cél_1[,...]";
		$csvhelp="catch-all: <b>*@innen.hu &rarr; pf@ide.hu</b>, alias domain: <b>*@innen.hu &rarr; @ide.hu </b>";

		import_route('alias', $mode, $csvformat, $csvhelp, $csvdata);
	}
	else
	{
		echo '<h4>Hibás paraméterezés.</h4>';
		pageclose();
		die();
	}
	DBclose();
	pageclose();
	exit (0);
}
