<?php

function do_import($csvformat, $csv_arr)
{

	global $adminlogin;
	global $clientid;

	$i_count=0;
	$csv_count=count($csv_arr);

	//start transaction
	DBquery("SET autocommit = 0;");
	DBquery("START TRANSACTION;");

	$stmt=DBpq_prepare("INSERT INTO `mail_users` SET `domainid`=?, `hostid`=?, `name`=?, `password`=?, `quota`=?, `active`=1, `modified`=NOW();");

	foreach($csv_arr as $line_no => $in_line)
	{
		//$csvformat="felhasználónév;[host/aldomain];domain;[jelszó];[tárhely_mb]";
		$i_name=strtolower($in_line[0]);
		$i_host=strtolower($in_line[1]);
		$i_domain=strtolower($in_line[2]);
		$i_password=$in_line[3];
		$i_quota=$in_line[4];

		$i_unidomain=unidom($i_domain);

		$no_dupe=true;

		if
		(
			($in_line[0]!="<DUPLIKÁLT>") &&
			check_clean_array(array($i_domain,$i_unidomain,$i_host)) &&
			mand_str($i_domain, 'Domainnév', false) &&
			check_format_domain($i_domain, false, false) &&
			(($d_domainid=get_domainid($i_unidomain))>0) &&
			(!$i_host || check_format_host($i_host, false)) &&
			(!$i_host || ($d_hostid=get_hostid($i_host, $d_domainid))>0)
		)
		{
			if (!$i_host) { $d_hostid=NULL; }
			$d_clientid=get_domain_cliid($d_domainid);
			$d_maxquota=get_mailquota($d_clientid);

			if
			(
				check_clean_array(array($i_name, $i_password, $i_quota)) &&

				mand_str($i_name, 'Felhasználónév', false) &&
				check_format_alnum_ext($i_name, 'Felhasználónév', false) &&
				($no_dupe=check_exist_mailuser($i_name, $d_domainid, $d_hostid, false)) &&

				opt_int_positive($i_quota, 'Tárhely', false)
			)
			{
				null_if_false($d_hostid);
				$d_newpass=gen_pass($i_password, false);
				if (!$i_quota || $i_quota==0 || $i_quota>$d_maxquota)
				{
					$i_quota=$d_maxquota;
				}

				// here we do the import
				//`mail_users` SET `domainid`=?, `hostid`=?, `name`=?, `password`=?, `quota`=?
				$nvalues=array('iissi', $d_domainid, $d_hostid, $i_name, $d_newpass, $i_quota);
				DBpq_execute($stmt, $nvalues);

				$i_count++;
				unset($csv_arr[$line_no]);

				logme("Mailbox imported: ".$i_name."@".gen_fqdn($i_host, $i_domain));
			}
			elseif(!$no_dupe)
			{
				array_unshift($csv_arr[$line_no],"<DUPLIKÁLT>");
			}
		}
	}

	DBpq_close($stmt);

	// commit transaction
	DBquery("COMMIT;");
	DBquery("SET autocommit = 1;");

	if ($i_count>0)
	{
		echo "<h4>Sikeresen importálva $i_count postafiók (összesen: $csv_count).</h4><br />";
	}
	else
	{
		echo "<h4>Sikertelen importálás.</h4><br />";
	}
	return ($csv_arr);
}
