<?php

function do_import($csvformat, $csv_arr)
{

	global $adminlogin;
	global $clientid;

	$i_count=0;
	$csv_count=count($csv_arr);

	//start transaction
	DBquery("SET autocommit = 0;");
	DBquery("START TRANSACTION;");

	$stmt=DBpq_prepare("INSERT INTO `mysql` SET `clientid`=?, `name`=?, `password`=?, `modified`=NOW();");

	foreach($csv_arr as $line_no => $in_line)
	{
		//$csvformat="ügyfélnév;domainnév;dns_aktív;levelezés_aktív;[elsődleges_ip];[mx_rekord];[spf_extra]";
		$i_client=strtolower($in_line[0]);
		$i_name=strtolower($in_line[1]);
		$i_password=$in_line[2];

		$no_dupe=true;

		if
		(
			($in_line[0]!="<DUPLIKÁLT>") &&
			check_clean($i_client) &&
			mand_str($i_client, 'Ügyfél neve', false) &&
			check_format_alnum($i_client, 'ügyfélnév', false) &&
			(($d_clientid=get_clientid($i_client))>0)
		)
		{
			if
			(
				check_clean_array(array($i_name, $i_password)) &&
				mand_str($i_name, 'Adatbázisnév/Login', false) &&
				check_format_alnum($i_name, 'adatbázisnév-loginnév utótag') &&
				($no_dupe=check_exist_mysql($i_name, $d_clientid, false))
#				opt_pass($i_password, $i_password, $i_name, '', 0, false)
			)
			{
				$d_newpass=gen_pass($i_password, false);

				// here we do the import
				// `clientid`=?, `name`=?, `pass`=?, `modified`=NOW();
				$nvalues=array('iss', $d_clientid, $i_name, $d_newpass);
				DBpq_execute($stmt, $nvalues);

				$i_count++;
				unset($csv_arr[$line_no]);
				logme("Mysql user/db imported: ".str_pad($d_clientid, 4, '0', STR_PAD_LEFT).'_'.$i_name.'.');
			}
			elseif(!$no_dupe)
			{
				array_unshift($csv_arr[$line_no],"<DUPLIKÁLT>");
			}
		}
	}

	DBpq_close($stmt);

	// commit transaction
	DBquery("COMMIT;");
	DBquery("SET autocommit = 1;");

	if ($i_count>0)
	{
		echo "<h4>Sikeresen importálva $i_count adatbázis (összesen: $csv_count).</h4><br />";

		activate_config('mysql_update');
		apply_activation();
	}
	else
	{
		echo "<h4>Sikertelen importálás.</h4><br />";
	}
	return ($csv_arr);
}
