<?php

function do_import($csvformat, $csv_arr)
{

	global $adminlogin;
	global $clientid;
	global $CONFIG;

	$i_count=0;
	$csv_count=count($csv_arr);

	//start transaction
	DBquery("SET autocommit = 0;");
	DBquery("START TRANSACTION;");

	$stmt=DBpq_prepare("INSERT INTO `vhosts` SET `domainid`=?, `host`=?, `alias`=?, `ext_alias`=?, `docroot`=?, `redirect`=?, `redirect_permanent`=?, `writable`=?, `upstream`=?, `extradir`=?, `ssl_on`=?, `ssl_mode`=?, `settings`=?, `nsettings`=?, `token`=?, `modified`=NOW();");

	foreach($csv_arr as $line_no => $in_line)
	{
		//$csvformat="domain;host;[alias1,...];[külső_alias1,...];[index_root];[átirányítás];[írható_dir1,...];[engine];[extra_dir1,...];[https];[csak_https];[apache_cfg_base64];[nginx_cfg_base64]";
		$i_domain=strtolower($in_line[0]);
		$i_host=strtolower($in_line[1]);
		$i_alias=csvl2multirow(strtolower($in_line[2]), ',');
		$i_extalias=csvl2multirow(strtolower($in_line[3]), ',');
		$i_docroot=$in_line[4];
		$i_redirect=$in_line[5];
		$i_redirect_permanent=$in_line[6];
		$i_writable=csvl2multirow(strtolower($in_line[7]), ',');
		$i_usid=$in_line[8];
		$i_extradir=csvl2multirow(strtolower($in_line[9]), ',');
		$i_ssl_on=$in_line[10];
		$i_ssl_mode=$in_line[11];
		$i_apache_settings_base64=$in_line[12];
		$i_nginx_settings_base64=$in_line[13];

		$i_unidomain=unidom($i_domain);

		$no_dupe=true;

		if
		(
			($in_line[0]!="<DUPLIKÁLT>") &&
			check_clean_array(array($i_domain,$i_unidomain)) &&
			mand_str($i_domain, 'Domainnév', false) &&
			check_format_domain($i_domain, false, false) &&
			(($d_domainid=get_domainid($i_unidomain))>0)
		)
		{
			if
			(
				check_clean_array(array($i_host, $i_alias, $i_extalias, $i_docroot, $i_redirect, $i_redirect_permanent, $i_writable, $i_usid, $i_extradir, $i_ssl_on, $i_ssl_mode, $i_apache_settings_base64, $i_nginx_settings_base64)) &&

				mand_str($i_host, 'Weboldal címe', false) &&
				check_format_vhost($i_host, true, false, false) &&
				($no_dupe=check_exist_vhost($i_host, $i_alias, $i_extalias, $d_domainid, false)) &&

				(!$i_alias || check_format_multirow_vhost($i_alias, false, false)) &&
				(!$i_extalias || check_format_multirow_vhost($i_extalias, true, false)) &&
				(!$i_docroot || check_format_dir($i_docroot, false)) &&
				(!$i_redirect || check_format_url($i_redirect, false)) &&
				opt_int($i_redirect_permanent, 'permanens átirányítás érték', false) &&
				(!$i_writable || check_format_multirow_dir($i_writable, false)) &&
				(!$i_usid || check_upstream($i_usid, $d_domainid, null, false)) &&
				(!$i_extradir || check_format_multirow_dir($i_extradir, false)) &&
				opt_int($i_ssl_on, 'https mód', false) &&
				opt_int($i_ssl_mode, 'csak https érték', false) &&
				(!$i_apache_settings_base64 || check_base64($i_apache_settings_base64, 'apache cfg', false)) &&
				(!$i_nginx_settings_base64 || check_base64($i_nginx_settings_base64, 'nginx cfg', false))
			)
			{
				null_if_false($i_alias);
				null_if_false($i_extalias);
				null_if_false($i_docroot);
				null_if_false($i_redirect);

				if ($i_redirect_permanent!=1)
				{
					$i_redirect_permanent=0;
				}

				if (!$i_writable)
				{
					$d_writable=implode("\n",$CONFIG['def_writable']);
				}
				else
				{
					$d_writable=$i_writable;
				}

				if (!$i_usid)
				{
					$us_aks=array_keys($CONFIG['upstream']);
					$i_usid=$us_aks[0];
				}

				null_if_false($i_extradir);

				if ($i_ssl_on==1)
				{
					$d_ssl_on=4;
					if ($i_ssl_mode==1)
					{
						$d_ssl_mode=1;
					}
					else
					{
						$d_ssl_mode=0;
					}
				}
				else
				{
					$d_ssl_on=0;
					$d_ssl_mode=0;
				}

				$d_apache_settings=base64_decode($i_apache_settings_base64);
				null_if_false($d_apache_settings);

				$d_nginx_settings=base64_decode($i_nginx_settings_base64);
				null_if_false($d_nginx_settings);

				$d_token=create_token(32);

				// here we do the import
				//`domainid`=?, `host`=?, `alias`=?, `ext_alias`=?, `docroot`=?, `redirect`=?, `writable`=?, `upstream`=?, `extradir`=?, `ssl_on`=?, `ssl_mode`=?, `settings`=?, `nsettings`=?, `token`=?, `modified`=NOW();");
				//`domainid`=?, `host`=?, `alias`=?, `ext_alias`=?, `docroot`=?, `redirect`=?, `redirect_permanent`=?, `writable`=?, `upstream`=?, `extradir`=?, `ssl_on`=?, `ssl_mode`=?, `settings`=?, `nsettings`=?, `token`=?, `modified`=NOW();");
				$nvalues=array('isssssisisiisss', $d_domainid, $i_host, $i_alias, $i_extalias, $i_docroot, $i_redirect, $i_redirect_permanent, $d_writable, $i_usid, $i_extradir, $d_ssl_on, $d_ssl_mode, $d_apache_settings, $d_nginx_settings, $d_token);
				DBpq_execute($stmt, $nvalues);

				$i_count++;
				unset($csv_arr[$line_no]);
				logme("Vhost imported: $i_host.$i_domain");
			}
			elseif(!$no_dupe)
			{
				array_unshift($csv_arr[$line_no],"<DUPLIKÁLT>");
			}

		}
	}

	DBpq_close($stmt);

	// commit transaction
	DBquery("COMMIT;");
	DBquery("SET autocommit = 1;");

	if ($i_count>0)
	{
		echo "<h4>Sikeresen importálva $i_count weboldal (összesen: $csv_count).</h4><br />";

		activate_config('apache_update');
		apply_activation();
	}
	else
	{
		echo "<h4>Sikertelen importálás.</h4><br />";
	}
	return ($csv_arr);
}
