<?php

function htmlheader() {

	global $CONFIG;

	header('Content-Type: text/html; charset=utf-8');
	echo "<!DOCTYPE html>\n";
	echo "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n";

	echo "<head>\n";
	echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
	echo "<link href=\"$CONFIG[rdir]/include/sys-style.css\" rel=\"stylesheet\" type=\"text/css\">\n";
	echo "<link href=\"$CONFIG[rdir]/config/style.css\" rel=\"stylesheet\" type=\"text/css\">\n";

	echo "<title>".$CONFIG['pagetitle']."</title>\n";

	echo "<script src=\"$CONFIG[rdir]/include/java.function.js\"></script>\n";
	echo "<script src=\"$CONFIG[rdir]/include/java.tablesort.js\"></script>\n";

	echo "</head>\n";
	echo "<body>\n";
	echo "<center>\n";
}

function pageclose() {
	echo "</center>\n";
	echo "</body>\n";
	echo "</html>\n";
}

function suicide() {
	pageclose();
	DBclose();
	die();
}

function reqvars() {

	global $adminlogin, $adminlevel, $clientid, $admclientid, $FILTER;

	//get user login data from GET/POST
	$admclientid=gp_int('admclientid');

	sess('admclientid');

	$clientid=$_SESSION['sysadmin_uid'];
	$adminlogin=$_SESSION['sysadmin_adminlogin'];
	$adminlevel=$_SESSION['sysadmin_adminlevel'];

	if ($admclientid!=0 && $adminlogin==1)
	{
		$clientid=$admclientid;
	} else {
		$admclientid=0;
		sess('admclientid');
	}

	$Ftmp=array();
	//get FILTER from GET/POST
	$Ftmp['listfilter']=gp_int('fi_listfilter');
	$Ftmp['statfilter']=gp_int('fi_statfilter');
	$Ftmp['domid']=gp_int('fi_domid');
	$Ftmp['hostid']=gp_int('fi_hostid');
	$Ftmp['nodeid']=gp_int('fi_nodeid');

	if ($Ftmp['nodeid']!=0 && (!(check_node($Ftmp['nodeid'],0)))) { $Ftmp['nodeid']=0; }

	if ($Ftmp['domid']!=0 && (!(check_domain($Ftmp['domid'],0)))) { $Ftmp['domid']=0; }
	if ($Ftmp['hostid']!=0 && (!(check_host($Ftmp['hostid'],0)))) { $Ftmp['hostid']=0; }

	if (($Ftmp['domid']==0) && ($Ftmp['hostid']!=0)) { $Ftmp['hostid']=0; }

	sess_arr('FILTER',$Ftmp);
}


function pageinit() {

	session_start();
	global $vGET, $vPOST;

	openlog('sys-admin[frontend]',0,LOG_DAEMON);

	$auth = new User();

	if ($_SESSION['sysadmin_logged']==false)
	{
		// parse POST variables
		$vPOST=getpostvars();

		// Empty GET when not logged in
		$vGET=array();

		$name=gp_str('formuser');
		$password=gp_str('formpass');

		if ($name || $password)
		{

			//reset POST if logging in
			$vPOST=array();

			DBconnect();

			if (!($auth->CheckLogin($name,$password)))
			{
				DBclose();
				htmlheader();
				topmenu_start();
				topmenu_end();
				loginbox();
				echo '<h3>A bejelentkezés sikertelen!</h3><br>';
				pageclose();
				die;
			} else {
				//logged in, render the page
				//htmlheader();
				reqvars();
				route();
				startmain();
			}
		}
		else
		{
			htmlheader();
			topmenu_start();
			topmenu_end();
			loginbox();
			pageclose();
			die;
		}
	}
	else
	{
		// parse GET and POST variables
		$vPOST=getpostvars();
		$vGET=getgetvars();

		//if logout
		$logout=gp_str('logout');
		if ($logout)
		{
			$auth->Logout();
			htmlheader();
			topmenu_start();
			topmenu_end();
			loginbox();
			echo '<h3>Sikeresen kilépett.</h3>';
			pageclose();
			die;
		}

		$auth->CheckSession();

		if ($_SESSION['sysadmin_timeout']==true)
		{
			htmlheader();
			topmenu_start();
			topmenu_end();
			loginbox();
			echo '<h3>A bejelentkezése lejárt!</h3>';
			pageclose();
			die;
		}

		//still logged in, render the page
		DBconnect();
		//htmlheader();
		reqvars();
		route();
		startmain();
	}
}


function route() {
	global $CONFIG;

	$in_func=gp_str('f');
	$in_edit=gp_str('e');

	$edit="list";
	$func="client";

	if (isset($in_func) && $in_func!="") {

		if (array_key_exists('disabled_functions', $CONFIG) && is_array($CONFIG['disabled_functions']) && in_array($in_func, $CONFIG['disabled_functions']))
		{
			$edit="list";
			$func="client";
		}
		else
		{
			if ($in_edit=="1") { $edit="edit"; }
			if ($in_edit=="2") { $edit="manage"; }
			if ($in_edit=="3") { $edit="import"; }

			$avail=scandir($CONFIG['adir']."/include/".$edit);
			if ($in_func!=".." && $in_func!="." && (in_array($in_func.".php",$avail)))
			{
		   		$func="$in_func";
			}
			elseif (file_exists($CONFIG['adir'].'/include/'.$edit.'/'.$edit.'.php'))
			{
		   		$func="$in_func";
			}
		}
	}
	else
	{
		if ($in_edit=="1") { exit (9); }
		if ($in_edit=="2") { exit (9); }
		if ($in_edit=="3") { exit (9); }
	}

	global $mainfunc;
	$mainfunc=$func;

	if (file_exists($CONFIG['adir'].'/include/'.$edit.'/'.$func.'.php'))
	{
		require_once $CONFIG['adir'].'/include/'.$edit.'/'.$func.'.php';
	}
	elseif (file_exists($CONFIG['adir'].'/include/'.$edit.'/'.$edit.'.php'))
	{
		require_once $CONFIG['adir'].'/include/'.$edit.'/'.$edit.'.php';
	}

}


function loginbox() {
	global $CONFIG;

	echo "<br />\n";
	echo "<table class=\"loginbox\">\n";
	echo "<tr>\n";
	echo "<td>\n";
	echo "<img src=\"$CONFIG[rdir]/image/login.png\">\n";
	echo "</td>\n";
	echo "<td>\n";
	echo "<h2>bejelentkezés</h2>\n";
	echo "<table class=\"login\" cellpadding=\"5\">\n";
	echo "<form action=\"".$_SERVER['SCRIPT_NAME']."\" method=\"post\">\n";
	echo "<tr>\n";
	echo "	<td>felhasználói&nbsp;név:</td>\n";
	echo "	<td>\n";
	echo "	<input class=\"text\" type=\"text\" name=\"formuser\" value=\"\">\n";
	echo "	</td>\n";
	echo "	</tr>\n";
	echo "<tr>\n";
	echo "	<td>jelszó:</td>\n";
	echo "	<td>\n";
	echo "	<input class=\"text\" type=\"password\" name=\"formpass\" value=\"\">\n";
	echo "	</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
	echo "	<td>&nbsp;</td>\n";
	echo "	<td>\n";
	echo "	<input type=\"submit\" value=\"OK\">\n";
	echo "	</td>\n";
	echo "</tr>\n";
	echo "</form>\n";
	echo "</table>\n";
	echo "</td>\n";
	echo "</tr>\n";
	echo "</table>\n";
	echo "<br />\n";

}

?>
