<?php

function startmain()
{
	global $CONFIG;
	global $adminlogin;
	global $adminlevel;
	global $clientid;
	global $FILTER;

	htmlheader();
	topmenu_start();
	sel_node();
	sel_client();
	sel_domain();
	sel_statfilter();
	topmenu_end();

	if ($_SESSION['sysadmin_logged']==true)
	{

		//pending kiirasa
		if (get_pending('apache_update') || get_pending('rights_update')) {
		echo "<div class=\"pending\"><b>Figyelem!</b> Függőben levő változások: 1 percen belül életbe lépnek. (<a href=\"".$_SERVER['SCRIPT_NAME']."?f=vhost\">Frissít</a>)</div>";
		}

		if (!($CONFIG['limit']['data']>0)) { $CONFIG['limit']['data']=1000; }
		if (!($CONFIG['limit']['cpu']>0)) { $CONFIG['limit']['cpu']=1000; }
		if (!($CONFIG['limit']['cpuperhit']>0)) { $CONFIG['limit']['cpuperhit']=1000; }

		$yds="-1 week";
		if ($FILTER['statfilter']==1) { $yds="-1 day"; }
		if ($FILTER['statfilter']==3) { $yds="-3 day"; }
		if ($FILTER['statfilter']==7) { $yds="-1 week"; }
		if ($FILTER['statfilter']==30) { $yds="-1 month"; }
		if ($FILTER['statfilter']==90) { $yds="-3 month"; }

		$stats=array();
		$ssql ="SELECT
				stats_vhost.vhostid AS vhostid,
				IFNULL(ROUND(AVG(stats_vhost.hits)),0) AS hits,
				IFNULL(ROUND(AVG(stats_vhost.data)),0) AS data,
				IFNULL(ROUND(AVG(stats_vhost.cpu)),0) AS cpu
			FROM stats_vhost
			LEFT JOIN vhosts ON stats_vhost.vhostid=vhosts.id
			LEFT JOIN domain ON vhosts.domainid=domain.id
			LEFT JOIN client ON domain.clientid=client.id
			WHERE stats_vhost.modified >= DATE_ADD(NOW(),INTERVAL $yds)
			";

		$ssql.=enforce_mysql_access();
#		if ($clientid == 0) {
#			$ssql.="GROUP BY stats_vhost.vhostid;";
#		} else {
#			$ssql.="AND client.id=$clientid
#				GROUP BY stats_vhost.vhostid;";
#		}

		$ssql.="GROUP BY stats_vhost.vhostid;";

		$sResult=DBquery($ssql);
		if ($sResult->num_rows) {
			while($sRow=$sResult->fetch_assoc()) {
			$stats[$sRow['vhostid']]=$sRow;
			}
		}

		$sql ="SELECT vhosts.id AS id, 
			vhosts.host AS hostname,
			vhosts.alias AS alias,
			vhosts.ext_alias AS ext_alias,
			vhosts.redirect AS redirect,
			vhosts.redirect_permanent AS redirect_permanent,
			vhosts.docroot AS docroot,
			vhosts.extradir AS extradir,
			vhosts.upstream AS upstream,
			vhosts.settings AS settings,
			vhosts.nsettings AS nsettings,
			vhosts.active AS active,
			vhosts.rights AS rights,
			vhosts.writable AS writable,
			vhosts.ssl_on AS ssl_on,
			vhosts.ssl_mode AS ssl_mode,
			IFNULL(vhosts.token, 'no_token') AS token,
			domain.name AS domain,
			client.name AS clientname,
			client.node AS node
			FROM vhosts
			LEFT JOIN domain ON vhosts.domainid=domain.id
			LEFT JOIN client ON domain.clientid=client.id
			WHERE 1
			";

		if (nonzero($FILTER['nodeid']))
		{
			$sql.="AND `client`.`node`=\"".$FILTER['nodeid']."\" ";
		}

		$sql.=enforce_mysql_access();
#		// client domainjei
#		if ($clientid != 0)
#		{
#		$sql.="AND client.id=\"$clientid\" ";
#		}

		// ha szurtuk
		if (nonzero($FILTER['domid']))
		{
			$sql.="AND domain.id=\"".$FILTER['domid']."\" ";
		}

		$sql.="GROUP BY vhosts.id
			ORDER BY domain.name, vhosts.host ";

		$sql.=";";


		$Result=DBquery($sql);

		echo "<table class='data' id='datatable'>";

		if ($Result->num_rows)
		{

			//kiiras
			echo "\n<thead><tr>";
			echo "<th class='hidetail' width='20px'>!</th>";
			echo "<th width='20px' class='detail'>#</th>";
			echo "<th class='hidetail'>Domain</th>";
			if ($CONFIG['nodes']>1) { echo "<th width='20px'>Szerver</th>";}
			echo "<th>Weboldal címe(i)</th>";
			echo "<th>Könyvár (átirányítás)</th>";
			echo "<th width='20px'>Extra</th>";
			echo "<th width='20px'>HTTPS</th>";
			echo "<th class='detail'>Engine</th>";
			echo "<th class='detail'>HITs</th>";
			echo "<th class='detail'>Forgalom</th>";
			echo "<th>CPU idő</th>";
			echo "<th>CPU/HIT</th>";
			echo "<th class='no-sort' width='20px'>Stat</th>";
			echo "<th class='no-sort detail' width='20px'>API</th>";
			echo "<th class='no-sort' width='20px'>Szerk</th>";
			echo "<th class='no-sort' width='20px'>Írható</th>";
			echo "<th width='20px'>Védelem</th>";
#			echo "<th class='no-sort' width='20px'>Install</th>";
			echo "<th width='20px'>Aktív</th>";
			echo "<th class='no-sort' width='20px'>Töröl</th>";
			echo "</tr></thead>\n";

		}
		else
		{
			echo "<tr><td><h3>nincsenek weboldalak</h3></td></tr>";
		}

		$i=1;
		$datasum=0;
		$cpusum=0;
		while($Row=$Result->fetch_assoc())
		{

			$vhid=$Row['id'];

			// get stats
			$stat_hits=0;
			$stat_data=0;
			$stat_cpu=0;
			$stat_cpuperhit=0;
			if (array_key_exists($vhid,$stats))
			{
				if (array_key_exists('hits', $stats[$vhid]))
				{
					$stat_hits=$stats[$vhid]['hits'];
				}
				if (array_key_exists('data', $stats[$vhid]))
				{
					$stat_data=$stats[$vhid]['data'];
				}
				if (array_key_exists('cpu', $stats[$vhid]))
				{
					$stat_cpu=$stats[$vhid]['cpu'];
				}
				if ($stat_hits>0)
				{
					$stat_cpuperhit=round($stat_cpu/$stat_hits*1000);
				}
			}

			$wwwprefix="<span style=\"color:#999; font-size:9px;\" >(www).</span>";

			if ($Row['hostname']=="") { $host="www"; } else { $host=$Row['hostname']; }
			if ($Row['docroot']=="") {$docroot="";} else {$docroot="/".$Row['docroot'];}

			$domain=domuni($Row['domain']);
			$domain_display=domuni($Row['domain'],"<span class=\"red\">","</span>");

			if ($host=="www") { $hostalias=""; } else {$hostalias="$wwwprefix";}

			$aliasarr=multirow2array($Row['alias']);
			$aliasrow="";
			foreach ($aliasarr as $alias)
			{
				$aliasrow=$aliasrow."$wwwprefix<b>$alias</b>.$domain_display<br>";
			}
			$xaliasrow=multirow2web($Row['ext_alias'], $wwwprefix);
			$extradirrow=multirow2web($Row['extradir']);
			//$settingsrow=multirow2web(htmlspecialchars($Row['settings']));
			$settingsrow=trim(htmlspecialchars($Row['settings']));
			$nsettingsrow=trim(htmlspecialchars($Row['nsettings']));

			$allsettingsrow="";

			if ($settingsrow!="")
			{
				$allsettingsrow="Apache:\n".$settingsrow;
			}
			if ($nsettingsrow!="")
			{
				if ($allsettingsrow!="")
				{
					$allsettingsrow=$allsettingsrow."\n\n";
				}
				$allsettingsrow=$allsettingsrow."Nginx:\n".$nsettingsrow;
			}

			$writablerow=trim(htmlspecialchars($Row['writable']));

			$token=$Row['token'];

			//if ($Row['data'] > $CONFIG['limit']['data'] || $Row['cpu'] > $CONFIG['limit']['cpu']) {
			if ($stat_data > $CONFIG['limit']['data'] || $stat_cpu > $CONFIG['limit']['cpu'])
			{
				//$icon="<img src=\"$CONFIG[rdir]/image/star.png\">";
				$icon="<a class='icon star'>1</a>";
				if ($i%2 == 0) { echo "<tr class=\"list-paros-premium\">"; } else { echo "<tr class=\"list-paratlan-premium\">"; }
			}
			else
			{
				//$icon="<img src=\"$CONFIG[rdir]/image/star-ro.png\">";
				$icon="<a class='icon star-ro'>0</a>";
				if ($i%2 == 0) { echo "<tr class=\"list-paros\">"; } else { echo "<tr class=\"list-paratlan\">"; }
			}

			// Start the table

			echo "<td class=\"hidetail\">$icon</td>";
			echo "<td class=\"detail\">$i.</td>";

			echo "<td class=\"hidetail\">$domain_display</td>";
			if ($CONFIG['nodes']>1)
			{
				if (array_key_exists($Row['node'], $CONFIG['node']))
				{
					echo "<td ><center><b class='node' id='node".$Row['node']."' title='".$CONFIG['node'][$Row['node']]['ip']."'>".$Row['node']."</b></center></td>";
				}
				else
				{
					echo "<td ><center><b class='node' title='Ismeretlen (".$Row['node'].")'>?</b></center></td>";
				}
			}

			if ($Row['ssl_on']==4) { $scheme='https'; } else { $scheme='http'; }

			echo "<td><a href=\"$scheme://$host.$domain\" target=\"_blank\">";
			echo "$hostalias<b>$host</b>.$domain_display";
			if ($aliasrow) {echo "<div class=\"tableindent\">$aliasrow</div>";}
			if ($xaliasrow) {echo "<div class=\"tableindent\">$xaliasrow</div>";}
			echo "</a></td>";

			if ($Row['redirect']=="")
			{
				echo "<td>".$CONFIG['vdir']."/$Row[clientname]/$Row[domain]/$host<b class=\"red\">$docroot</b>";
				if ($extradirrow) {echo "<div class=\"tableindent-red\" style=\"font-size:7pt;\">$extradirrow</div>";}
				echo "</td>";
			}
			else
			{
				if ($Row['redirect_permanent']==1)
				{
					$rpcomm=' <b class="red">301</b> ';
				}
				else
				{
					$rpcomm='';
				}
				//echo "<td><img src=\"$CONFIG[rdir]/image/redirect.png\"> <b>$Row[redirect]</b></td>";
				echo "<td><p class='icon redirect'>$rpcomm<b>$Row[redirect]</b></p></td>";
			}

			//echo "<td style=\"font-size:10px; max-width:200px;\">$settingsrow</td>";
			echo "<td class=\"c\">";

			if ($adminlogin==1)
			{
				if ($allsettingsrow=="")
				{
					//$settings_img='config.png';
					$settings_class='icon config';
					$settings_bool=0;
				}
				else
				{
					//$settings_img='warning.png';
					$settings_class='icon warning';
					$settings_bool=1;
				}
				//echo "<a href=\"javascript:Act('vhost','settings','$vhid')\"><img src=\"$CONFIG[rdir]/image/".$settings_img."\" title=\"$allsettingsrow\"></a></td>";
				echo "<a href=\"javascript:Act('vhost','settings','$vhid')\" class='".$settings_class."' title=\"$allsettingsrow\">$settings_bool</a></td>";
			}
			else
			{
				if ($allsettingsrow=="")
				{
					echo "-</td>";
				}
				else
				{
					//echo "<img src=\"".$CONFIG['rdir']."/image/warning.png\" title=\"$allsettingsrow\"></td>";
					echo "<a class='icon warning' title=\"$allsettingsrow\">1</a></td>";
				}
			}

			switch($Row['ssl_on'])
			{
				case 1:
					//$ssl_img='loading.gif';
					$ssl_class='icon loading';
					$ssl_txt='Adminisztrátorra vár';
					$ssl_editable=1;
					$ssl_editable_user=2;
					break;
				case 2:
					//$ssl_img='loading.gif';
					$ssl_class='icon loading';
					$ssl_txt='Kulcsok generálása folyamatban';
					$ssl_editable=2;
					$ssl_editable_user=2;
					break;
				case 3:
					//$ssl_img='loading.gif';
					$ssl_class='icon loading';
					$ssl_txt='Validálásra vár';
					$ssl_editable=1;
					$ssl_editable_user=2;
					break;
				case 4:
					switch($Row['ssl_mode'])
					{
						case 0:
							//$ssl_img='ssl-partial.png';
							$ssl_class='icon ssl-partial';
							$ssl_txt='Aktív'."\n".'HTTP+HTTPS';
							break;
						case 1:
							//$ssl_img='ssl-on.png';
							$ssl_class='icon ssl-on';
							$ssl_txt='Aktív'."\n".'Csak HTTPS';
							break;
						default:
							//$ssl_img='ssl-on.png';
							$ssl_class='icon ssl-on';
							$ssl_txt='Aktív';
							break;
					}
					$ssl_editable=1;
					$ssl_editable_user=0;
					break;
				default:
					//$ssl_img='ssl-off.png';
					$ssl_class='icon ssl-off';
					$ssl_txt='Inaktív'."\n".'Csak HTTP';
					$ssl_editable=1;
					$ssl_editable_user=0;
					break;
			}

			if ($adminlogin!=1) { $ssl_editable=$ssl_editable_user; }

			if (!($Row['active'])) { $ssl_editable=0; }

			echo "<td class=\"c\">";
			if ($ssl_editable==1)
			{
				echo "<a href=\"javascript:Act('vhost','ssl','$vhid')\" class='".$ssl_class."' title=\"".$ssl_txt."\">a".$Row['ssl_on'].$Row['ssl_mode']."</a>";
			}
			elseif ($ssl_editable==2)
			{
				echo "<a href=\"".$_SERVER['SCRIPT_NAME']."?f=vhost\" class='".$ssl_class."' title=\"".$ssl_txt."\">a".$Row['ssl_on'].$Row['ssl_mode']."</a>";
			}
			else
			{
				echo "<a class='".$ssl_class."' title=\"".$ssl_txt."\">a".$Row['ssl_on'].$Row['ssl_mode']."</a>";
			}
			//echo "<img src=\"$CONFIG[rdir]/image/".$ssl_img."\" title=\"".$ssl_txt."\">";
#			if ($ssl_editable>0)
#			{
#				echo "</a>";
#			}
			echo "</td>";

			if (array_key_exists($Row['upstream'], $CONFIG['upstream']) && array_key_exists($Row['node'], $CONFIG['node']))
			{
				$usname=$CONFIG['upstream'][$Row['upstream']]['name'];
				if (array_key_exists('upstreams', $CONFIG['node'][$Row['node']]) && (! in_array($Row['upstream'], $CONFIG['node'][$Row['node']]['upstreams']) ) )
				{
					$usname='Inaktív ('.$usname.')';
				}
			}
			else
			{
				$usname='Ismeretlen ('.$Row['upstream'].')';
			}
			echo "<td class=\"c detail\">".$usname."</td>";

			echo "<td class=\"r detail\">".$stat_hits."</td>";
			echo "<td class=\"detail\">".percentgraph($stat_data, $CONFIG['limit']['data'], "MB")."</td>";
			echo "<td>".percentgraph($stat_cpu, $CONFIG['limit']['cpu'], "s")."</td>";
			echo "<td>".percentgraph($stat_cpuperhit, $CONFIG['limit']['cpuperhit'], "ms")."</td>";

#			if ($Row['redirect']=='')
#			{
				//echo "<td class=\"c\"><a href=\"javascript:Manage('vhost','$vhid')\"><img src=\"$CONFIG[rdir]/image/manage_vhost.png\"></a></td>";
				echo "<td class=\"c\"><a href=\"javascript:Manage('vhost','$vhid')\" class='icon manage_vhost'></a></td>";
				//echo "<td class=\"c detail\"><a href=\"javascript:Manage('vhost','$vhid')\"><img src=\"$CONFIG[rdir]/image/api.png\"></a></td>";
				echo "<td class=\"c detail\"><a href=\"javascript:Manage('vhost','$vhid')\" class='icon api'></a></td>";
#			}
#			else
#			{
#				echo "<td class=\"c\">-</td>\n";
#				echo "<td class=\"c detail\">-</td>\n";
#			}

			//echo "<td class=\"c\"><a href=\"javascript:Act('vhost','edit','$vhid')\"><img src=\"$CONFIG[rdir]/image/edit.png\"></a></td>";
			echo "<td class=\"c\"><a href=\"javascript:Act('vhost','edit','$vhid')\" class='icon edit'></a></td>";

#			if ($Row['redirect']=='')
#			{
				//echo "<td class=\"c\"><a href=\"javascript:Act('vhost','wdirs','$vhid')\"><img src=\"$CONFIG[rdir]/image/folder-edit.png\" title=\"$writablerow\"></a></td>";
				echo "<td class=\"c\"><a href=\"javascript:Act('vhost','wdirs','$vhid')\" class='icon folder-edit' title=\"$writablerow\"></a></td>";

#				echo "<td class=\"c\"><a href=\"javascript:Act('vhost','rightsfix','$vhid',1)\">";

				echo "<td class=\"c\">";
				if ($Row['rights']==0)
				{
#					echo "<a href=\"javascript:Act('vhost','rights','$vhid')\">";
#					echo "<img src=\"$CONFIG[rdir]/image/lock.png\">";
					echo "<a href=\"javascript:Act('vhost','rights','$vhid')\" class='icon lock'>a".$Row['rights'];
				}
				elseif ($Row['rights']==1)
				{
#					echo "<a href=\"javascript:Act('vhost','rights','$vhid')\">";
#					echo "<img src=\"$CONFIG[rdir]/image/error.png\">";
					echo "<a href=\"javascript:Act('vhost','rights','$vhid')\" class='icon error'>a".$Row['rights'];
				}
				else
				{
#					echo "<a href=\"".$_SERVER['SCRIPT_NAME']."?f=vhost\">";
#					echo "<img src=\"$CONFIG[rdir]/image/loading.gif\">";
					echo "<a href=\"".$_SERVER['SCRIPT_NAME']."?f=vhost\"  class='icon loading'>a".$Row['rights'];
				}
				echo "</a></td>\n";
#			}
#			else
#			{
#				echo "<td class=\"c\">-</td>\n";
##				echo "<td class=\"c\">-</td>\n";
#				echo "<td class=\"c\">-</td>\n";
#			}

#			echo "<td class=\"c\"><a href=\"javascript:Act('vhost','rightswr','$vhid',1)\"><img src=\"$CONFIG[rdir]/image/lockopen.png\"></a></td>";

			echo "<td class=\"c\"><a href=\"javascript:Act('vhost','toggle','$vhid',1)\" ";
#			if ($Row['active']) { echo "<img src=\"$CONFIG[rdir]/image/ok.png\">";
#			} else { echo "<img src=\"$CONFIG[rdir]/image/off.png\">"; }
			if ($Row['active']) { echo "class='icon ok' >1"; } else { echo "class='icon off' >0"; }
			echo "</a></td>";

			//echo "<td class=\"c\"><a href=\"javascript:Act('vhost','del','$vhid',1)\"><img src=\"$CONFIG[rdir]/image/delete.png\"></a></td>\n";
			echo "<td class=\"c\"><a href=\"javascript:Act('vhost','del','$vhid',1)\" class='icon delete'></a></td>\n";

			$i++;
			echo "</tr>\n";
		} //while end

		echo "</table>\n";
		tablesorter();

		echo "
			<div class=\"tip\"><b>Tipp:</b> új weboldal létrehozásához használja a fenti menüben az <span class=\"addnew\" onclick=\"javascript:Act('vhost','new')\">Új</span> gombot.<br />
			(a gomb akkor jelenik meg, ha a <b>Weboldalak</b> ikon fölé viszi az egérkurzort)</div>
		";

	}

	DBclose();
	pageclose();
}
